/*
 * Game EC version 2.0 (Sep 20, 2018)
 */
 
var debug = false;
var isSimulation = false;

var base = "api/";
//var base = 'http://api.66ztc.cn/api/';
//var base = 'http://123.206.177.195:8001/api/';
var apiCode = "GameEC";
var gameName = "情绪";
var mainPage = "main-page";

var currentMsg;
var finishMsg = null;
var points = 10000;
var gameover = false;

var textPoints;
var timer1, timer2, timer3, timer4, timer5, timer6;

var speaking = false;
var inWaiting = false;
var countdown = 12;
var step = 0;
var iCurrent = 0;
var selectCount = 0;
var errCount = 1;
var targetEmotion;
var currentTime, thinkTime, moveTime, currentAction;

var NumChoices = 2;

//var tellerQuitReasons = ["看不到对方的反馈"];
//var listenerQuitReasons = ["完全听不到对方声音","听不清对方声音"];

//only for test simulation
if(isSimulation){
	var JavaScriptInterface = null;
	var selectMsg = null;
	var lastMsg = null;

	var lastMsgString = '{"isright": true, "finished": true, "score": 653.0, "totalscore":1232.0, "time": 96450.0, "steps": 91.0, "next": 3.0, "finishtime": "2017-04-27 16:30:00", "type": "finish"}';
	//var finishString = '{"isright": "true", "next": 3, "score": 0, "time": 36511, "errorcount": 0, "type": "finish",}';
	var selectString = '{"isright": "false", "next": 0, "score": 2000}';

	//only for test simulation
	var tellerInitString = '{"code": 200, "request": "GetInitInfo", "info":\
	{"level":2, "countdown": 8394, "timelimit": 30, "answerscore": [3000,1600,1000,0], "timescore": 100, "content": "你穿这件更好看",\
	"emotions": [ { "id": 63, "name": "钟爱" }, { "id": 21, "name": "嫉妒" }, { "id": 27, "name": "瞌睡" }, { "id": 40, "name": "谦虚" } ], "target": 63 }}'

	var listenerInitString = '{"code": 200, "request": "GetInitInfo", "info":\
	{"level":2, "countdown": 8394, "timelimit": 30, "answerscore": [2000,1600,1000,0], "timescore": 40, "content": "你穿这件更好看",\
	"emotions": [ { "id": 63, "name": "钟爱" }, { "id": 21, "name": "嫉妒" }, { "id": 27, "name": "瞌睡" }, { "id": 40, "name": "谦虚" } ]}}'
}

function onInit(msg){

	if(msg.matchidx != undefined){
		matchidx = msg.matchidx;
	}
	
	currentMsg = msg;
//	answerscore = msg.answerscore;
	points = msg.answerscore[0];
//	timescore = msg.timescore/10;

//	titleHeight =  document.getElementById("points").scrollHeight;
//	titleHeight = 0;
	
	if(msg.level != undefined){
		NumChoices = 2 + msg.level;
	}
	
	if(msg.target != undefined){
		//the teller case
		role = 'teller';
		
		JavaScriptInterface.nativeCommand('startVoice', '');
		
		document.getElementById("content").innerHTML = msg.content;
		document.getElementById("prompt1").style.visibility = "visible";
		document.getElementById("content").style.visibility = "visible";
		document.getElementById("countdown").style.visibility = "visible";
//		document.getElementById("startButton").style.visibility = "visible";
		
//		initButton('startButton', 'white');
		timer4 = setTimeout("initButton('startButton', 'white');", 2000);

		for(var i=1; i<NumChoices+1; i++)
		{
			if(msg.emotions[i-1].id == msg.target){
				targetEmotion = msg.emotions[i-1].name;
//				targetEmotionOder = i;
//				document.getElementById("c"+i).style.backgroundColor = "rgb(20,216,118)";
			}
		}
		
		if(msg.countdown > 0){
			countdown = Math.floor(msg.countdown/1000) + 1;
			if(countdown > 0){
				timer1 = setInterval("countdown--; document.getElementById('countdown').innerHTML = countdown;", 1000);
			}
			timer2 = setTimeout(onStart, msg.countdown);
		} else {
			onStart();
		}

	} else {
		//the listerner case when targetshapes is undefined
		role = 'listener';
		
		document.getElementById("prompt2").innerHTML = "对方将朗读一段句子，请仔细聆听";
		document.getElementById("prompt2").style.visibility = "visible";
		document.getElementById("statement").style.visibility = "visible";
		
		document.getElementById("contentref").innerHTML = msg.content;

		if(isSimulation){
			timer2 = setTimeout("start()", msg.countdown);
		}
		//quit if the teller has no response (network problem, teller's APP problem etc.) 
		timer1 = setTimeout("onCountdownTimeout()", 30000);
	}
		
	document.getElementById("c1").innerHTML = msg.emotions[0].name;
	document.getElementById("c1").emotionID = msg.emotions[0].id;	
	document.getElementById("c1a").innerHTML = msg.emotions[0].name;
	document.getElementById("c1a").emotionID = msg.emotions[0].id;
	
	document.getElementById("c2").innerHTML = msg.emotions[1].name;
	document.getElementById("c2").emotionID = msg.emotions[1].id;	
	document.getElementById("c2a").innerHTML = msg.emotions[1].name;
	document.getElementById("c2a").emotionID = msg.emotions[1].id;
		
	if(NumChoices > 2){
		document.getElementById("c3").innerHTML = msg.emotions[2].name;
		document.getElementById("c3").emotionID = msg.emotions[2].id;
		document.getElementById("c3a").innerHTML = msg.emotions[2].name;
		document.getElementById("c3a").emotionID = msg.emotions[2].id;	
	}
	
	if(NumChoices > 3){
		document.getElementById("c4").innerHTML = msg.emotions[3].name;
		document.getElementById("c4").emotionID = msg.emotions[3].id;
		document.getElementById("c4a").innerHTML = msg.emotions[3].name;
		document.getElementById("c4a").emotionID = msg.emotions[3].id;
	}
}

function onCountdownTimeout(){
	if(!quitSent){
		JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"游戏结束\",\"msg\":\"超时：断网或对方软件异常(804)\",\"t\":\"6\"}');
		requestServer("Game", "Quit", "reason=NET:countdown_timeout&matchidx="+matchidx);
		quitSent = true;
	}
	timer4 = setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 3000);
	if(isSimulation){
		alert("countdown timeout!");
	}
}

//this function called only at the teller side
function onStart(){

//	var jMsg = '{"type": "start"}';
//	JavaScriptInterface.nativeSendMsg('peer', jMsg);
	sendPeerMsg('start');
	if(debug){
//		document.getElementById('debug').innerHTML += '<br /><br />dest: peer<br />msg: ' + jMsg;
	}
	
	requestServer(apiCode, "StartNow");
	
	clearInterval(timer1);
	clearTimeout(timer2);
	start();
}

//this function called at both the teller and the listener side
function start(){

	document.getElementById('titlebar').style.visibility = "visible";
	startCountdownClock(currentMsg.timelimit);
	
//	document.getElementById("points").style.visibility = "visible";
	if(role == 'teller'){
		document.getElementById('titlebar').style.width = "100%";
		JavaScriptInterface.nativeCommand('micOn', '');
		requestServer("GameLog", "Add", "logtype=start&details=micOn");

		countdown = 20;
		document.getElementById("countdown").innerHTML = countdown;
		timer1 = setInterval(onCountdown, 1000);
		speaking = true;

		document.getElementById("prompt1").innerHTML += '<span style="color:#FFFFFF; font-size: 2rem;">' + targetEmotion + '</span>';
		document.getElementById("prompt2").style.visibility = "visible";
		document.getElementById("choicesview").style.visibility = "visible";
		
		if(isSimulation){
//			timer6 = setTimeout("onNativeMsg('peer', jMsgBadSound)", 5000);
			timer6 = setTimeout("onBadSound()", 5000);
		}

//		document.getElementById("c"+targetEmotionOder).style.backgroundColor = "rgb(20,216,118)";
//		document.getElementById("c"+targetEmotionOder).style.border = "none";		

//		timer5 = setTimeout("JavaScriptInterface.nativeSendMsg('peer', jMsgPing);", 15000);
//		timer6 = setTimeout("onPingFailed();", 20000);
	} else {
		clearTimeout(timer1);
		document.getElementById("micoff").style.visibility = "visible";
		document.getElementById('titlebar').style.left = "2rem";
		document.getElementById('titlebar').style.right = "0px";

		document.getElementById("prompt1").style.visibility = "visible";
		document.getElementById("prompt1").innerHTML = "请选择你听到的情绪";
		document.getElementById("choices").style.visibility = "visible";
		document.getElementById("prompt2").style.visibility = "hidden";
		document.getElementById("statement").style.visibility = "hidden";
		document.getElementById("prompt3").innerHTML = "对方朗读的句子为：";
		document.getElementById("contentref").style.visibility = "visible";

//		document.getElementById("reportMsgButton").style.visibility = "visible";
		document.getElementById("badsndButton").style.visibility = "visible";
		document.getElementById("reportButton").style.visibility = "visible";
		document.getElementById("prompt3").style.visibility = "visible";
		
		for(var i=1; i<NumChoices+1; i++){
			initButton('c'+i, null);
		}
//		initButton('c1', null);	
//		initButton('c2', null);
//		initButton('c3', null);
//		initButton('c4', null);
		initButton('badsndButton', 'white');
		initButton('reportButton', 'white');
		
//		timer6 = setTimeout("onPingFailed();", 30000);
	}
	document.getElementById("startButton").style.visibility = "hidden";

	textPoints = document.getElementById('points');
	timer2 = setInterval(displayPoints, 100);

	var gameDate = new Date();
	currentTime = gameDate.getTime();
	startHeartbeat();
}

function onCountdown(msg){
	countdown--;
	document.getElementById("countdown").innerHTML = countdown;
	
	if(countdown == 0){
		clearInterval(timer1);
		if(speaking){
			document.getElementById("countdown").innerHTML = '<span style="font-size:6vmin">朗读时间到。麦克风已关闭</span>';
			JavaScriptInterface.nativeCommand('endVoice', '');
//			JavaScriptInterface.nativeSendMsg('peer', jMsgVoiceCut);
			sendPeerMsg('voicecut');
			document.getElementById("badsndAlert").style.visibility = "hidden";
//			JavaScriptInterface.nativeCommand('micOff', '');
		}
	}
}

function selectEmotion(i){
	if(role == 'teller' || i<1 || i>NumChoices || document.getElementById("c"+i).selected || inWaiting){
		return;
	}
	
	inWaiting = true;
	iCurrent = i;
		
	var param = 'emotionid=' + 	document.getElementById("c"+i).emotionID;
	requestServer(apiCode, "SubmitEmotion", param);
	
	if(isSimulation){
		onFinish(selectMsg);
	}

	
	if(debug){
		document.getElementById('debug').innerHTML = '<br /><br />dest: server<br />msg: ' + param;
	}
}

/*
function onSelect(msg){
	document.getElementById("c" + msg.order + "a").style.backgroundColor = "rgb(144,144,144)";
	document.getElementById("c" + msg.order + "a").style.border = "none";
}
*/

function onGameTimeout(){
	if(role == 'listener'){
		requestServer(apiCode, "Zero");
	}
	clearInterval(timer1);
	if(isSimulation){
		alert("game timeout");
	}
}

function onFinish(msg){
	//on response from the server for Move and Zero request, only use to check finishing of the game
	inWaiting = false;
	if(points > 0){
		points = msg.score;
	}
	textPoints.innerHTML = '得分 ' + points;
	
	if(role == 'listener' && iCurrent != 0){
		document.getElementById("c"+iCurrent).selected = true;
//		document.getElementById("c"+iCurrent).style.backgroundColor = "rgb(144,144,144)";
		document.getElementById("c"+iCurrent).style.border = "none";
//		document.getElementById("c"+iCurrent).style.color = "white";
		
		document.getElementById("c"+iCurrent).style.background = "linear-gradient(30deg, rgb(144,144,144) 48%, red 48%, red 52%, rgb(144,144,144) 52%)";
	}
	
	if(msg.next == 0){
//		var jMsg = '{"type": "syncPoints", "order":' + iCurrent + ', "points":' + points +'}';
//		JavaScriptInterface.nativeSendMsg('peer', jMsg);
		sendPeerMsg('syncPoints', {"order":iCurrent, "points":points});
		document.getElementById("bubble").innerHTML = '-' + (currentMsg.answerscore[errCount-1] - currentMsg.answerscore[errCount]);
		document.getElementById("bubble").style.visibility = "visible";
		timer4 = setTimeout("document.getElementById('bubble').style.visibility = 'hidden'", 1000);
		document.getElementById("prompt2").innerHTML = "你还有<span style='font-size:30px;'> " + (3-errCount) + " </span>次选择机会";
		document.getElementById("prompt2").style.top = "16rem";
		document.getElementById("prompt2").style.visibility = "visible";

		errCount++;
		
		return;
	}
	
	gameover = true;
	clearInterval(timer2);
	if(msg.isright == true || msg.isright == 'true'){
		document.getElementById("snd").play();
	}
	JavaScriptInterface.nativeCommand('endVoice', ''); 
	nextGame = msg.next;

	if(role == 'listener'){
//		msg.type = 'finish';
//		var jMsg = toJson(msg);
//		var jMsg = JSON.stringify(msg);
//		JavaScriptInterface.nativeSendMsg('peer', jMsg);
		sendPeerMsg('finish', msg);
		
		if(debug){
//			document.getElementById('debug').innerHTML += '<br /><br />dest: peer<br />msg: ' + jMsg;
		}
	} else {
		clearInterval(timer1);
		JavaScriptInterface.nativeCommand('micOff', '');
	}
	
	//if we need to delete all block elements?
	document.getElementById("main-page").style.display = "none";
	document.getElementById("result-page").style.visibility = "visible";

	document.getElementById("score").innerHTML = msg.score;
//	document.getElementById("details").style.visibility = "hidden";
//	document.getElementById("details").innerHTML += "<p><b>参与者：</b>" + pair + "</p><p><b>日期：</b>" + msg.finishtime + "</p><p><b>游戏时间：</b>" + msg.time + "</p>";
//	document.getElementById("details").innerHTML += "<p><b>参与者：</b>" + pair + "</p><p><b>日期：</b>" + msg.finishtime + "</p>";

//	if(msg.totalscore != undefined){
//		totalscore = msg.totalscore;
//	}
	
	//keep it for use in total score page
	if(msg.next == 3){
		finishMsg = msg;
	}
	
//	document.getElementById("result-page").addEventListener("touchstart", onNextStep, false);
//	document.getElementById("result-page").addEventListener("mousedown", onNextStep, false);
	timer3 = setTimeout(onNextStep, 5000);
}

function onReport(){
	requestServer("Game", "Report");
	if(isSimulation){
		onNativeMsg('server', '{"code": 200}');
	}
}

function displayVoiceCut(){
	document.getElementById("badsndButton").style.visibility = "hidden";
	
	document.getElementById("badsndAlert").innerHTML = "对方已完成朗读";
	document.getElementById("badsndAlert").style.top = "";
	document.getElementById("badsndAlert").style.bottom = "6rem";
	document.getElementById("badsndAlert").style.right = "15%";
	document.getElementById("badsndAlert").style.animationPlayState = "running";
	document.getElementById("badsndAlert").style.visibility = "visible";
}

function onNextStep(){

	switch(nextGame){
	case 3:
	case '3':
	case '3.0':
		clearInterval(timer5);		
		showFinalResult();
		break;
	case 2:
	case '2':
	case '2.0':
		JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"正在互换角色...\",\"t\":\"3\"}');
	case 1:
	case '1':
	case '1.0':
		document.location.reload();
		break;
	}
}

function displayPoints(){
	points = points - currentMsg.timescore/10;
	if(points <= 0){
		clearInterval(timer2);
		points = 0;
		
		if(role == 'listener'){
			requestServer(apiCode, "Zero");
		}
		
		//test simulation
		if(isSimulation){
			onFinish(lastMsg);
		}
	}
	
	textPoints.innerHTML = '得分 ' + points;
}

function showGameResult(){
	// no customized setting
	return;
}

function initGame(){
	
//	genericInit();

	//following is EC2 specific initialization without need of the token
	currentAction = 0;

	if(isSimulation){
		selectMsg = eval("(" + selectString + ")");
		lastMsg = eval("(" + lastMsgString + ")");
	}
}

function onGameNativeMsg(source, msg){
	
//	var msg = eval("(" + jMsg + ")");
	
	switch(source){
	case 'server':
		switch(msg.request){
		case 'GetInitInfo':
			onInit(msg.info);
			break;
		case 'SubmitEmotion':
		case 'Zero':
			onFinish(msg.info);
			break;
		case 'Report':
			JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"服务器已收到举报\",\"t\":\"3\"}');
			break;
		}
		break;
	case 'peer':
		switch(msg.type)
		{
		case 'start':
			start();
			break;
		case 'syncPoints':
			points = msg.points;
			document.getElementById("c" + msg.order + "a").style.background = "linear-gradient(30deg, rgb(144,144,144) 48%, red 48%, red 52%, rgb(144,144,144) 52%)";
			document.getElementById("c" + msg.order + "a").style.border = "none";
			document.getElementById("c" + msg.order + "a").style.visibility = "visible";
			document.getElementById("prompt3").style.visibility = "visible";
			break;
		case 'finish':
			onFinish(msg);
			break;
		case 'voicecut':
			displayVoiceCut();
			break;
		}
		
		break;
	case 'system':
		if(debug){
//			document.getElementById('debug').innerHTML = 'source: ' + source + '<br />msg: ' + jMsg;
		}
		if(gameover){
			return;
		}
		switch(msg.code)
		{
		case 200:
		case '200':
		case '200.0':
		case 208:
		case '208':
		case '208.0':
			JavaScriptInterface.nativeCommand('micOff', '');
			break;
		}
	}
}
