﻿$(document).ready(function () {
    if (isSimulation) {
        getInfo();
    }
    else {
        JavaScriptInterface.nativeCommand('getToken', '');
        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"证书\"}');
    }
});

var idx = 0;

function submitComment() {
    var username = $("#username").val();
    var idnumber = $("#idnumber").val();
    var studentid = $("#studentid").val();

    username = username.replace(/\"/g, "").replace(/\'/g, "");
    idnumber = idnumber.replace(/\"/g, "").replace(/\'/g, "");
    studentid = studentid.replace(/\"/g, "").replace(/\'/g, "");
    //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"' + username + '\"}');

    if (username.length == 0 || username == '请输入真实姓名') {
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"请输入真实姓名！\",\"t\":\"3\"}');
        return false;
    }
    if (idnumber.length == 0 || idnumber == '请输入身份证号') {
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"请输入身份证号！\",\"t\":\"3\"}');
        return false;
    }
    var regidnumber = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
    if (!regidnumber.test(idnumber)) {
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"请输入正确的身份证号！\",\"t\":\"3\"}');
        return false;
    }  
    if (studentid.length == 0 || studentid == '请输入学号') {
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"请输入学号！\",\"t\":\"3\"}');
        return false;
    }
    if (idx == 0) {
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"Idx错误！\",\"t\":\"3\"}');
        return false;
    }
    var postinfo = '{"idx": "' + idx + '", "username": "' + username + '", "idnumber": "' + idnumber + '","studentid": "' + studentid + '"}';
    requestServer("League/SubmitCertInfo", "", postinfo);
}


function getInfo() {
    if (isSimulation) {

        var jMsg = sim.certinfo1;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }


    requestServer("League/GetCertInfo");
}

function showInfo(msg) {
    var info = "";
    switch (msg.info.status) {
        case 0:
        case 0.0:
        case "0":
            //填信息
            $(".inputinfo").show();
            $(".msginfo").hide();
            $(".certpic").hide();
            idx = msg.info.idx;
            break;
        case -1:
            // 无资格
            info = "您没有获得证书。<br /><br />您没有获得证书。只有参加了本季联赛，且最终位列黄金联赛、铂金联赛或钻石联赛才能获得证书。";
            $(".inputinfo").hide();
            $(".msginfo").show();
            $(".certpic").hide();
            break;
        case 1:
            info = "请联系客服人员了解证书进度。客服微信号：Ms_Elvinia";
            $(".inputinfo").hide();
            $(".msginfo").show();
            $(".certpic").hide();
            break;
        // 证书制作中
        case 9:
            info = "请添加客服微信：Ms_Elvinia，按要求提交相关证明材料审核。审核通过后将发放证书。";
            // 信息填写完成

            $(".inputinfo").hide();
            $(".msginfo").show();
            $(".certpic").hide();
            break;
        case 2:
            // 显示证书
            info = "如需纸质证书，请客服人员联系。客服微信号：Ms_Elvinia";
            $(".certpic").attr("src", "http://www.66ztc.cn/imgcert/" + msg.info.imgurl);
            $(".inputinfo").hide();
            $(".msginfo").show();
            $(".certpic").show();
            break;
    }
    $(".msginfo").html(info);
}

// JavaScript source code
function onNativeMsg(source, jMsg) {
    var msg = eval("(" + jMsg + ")");
    //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case 'server':
            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                if (msg.request == "GetCertInfo")
                    showInfo(msg);
                else if (msg.request == "SubmitCertInfo") {
                    JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"提交成功！\",\"t\":\"3\"}');
                    //showInfo(new { code: 200, info: new { status: 9 } });
                    var m = '{ "code": 200, "info": { "status": 9} }';
                    showInfo(eval("(" + m + ")"));
                }
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    //JavaScriptInterface.nativeCommand('exit', '');
                    //window.history.back();
                    window.location.href = "my.html";
                    break;
                case 223:
                case '223':
                case '223.0':
                    token = msg.info;
                    getInfo();
                    // initStepTwo();
                    break;
                case 225:
                case '225':
                case '225.0':
                    //$("#version").html(msg.info);
                    break;
                default:
                    break;
            }
    }
}