function getGameName(gamecode) {
    switch (gamecode) {
        case 'PS2S': return '沟通成本';
        case 'PS2C': return '说人话';
        case 'PA': return '有效说服';
        case 'PAN': return '面试沟通';
        case 'PAM': return '面试沟通';
    }
    return "";
}

function getInfo() {
    app.gamecode = GetQueryString("gamecode");
    var gamename = getGameName(app.gamecode);
    SetTitle("成绩详情-" + gamename);
    if (isSimulation) {
        var jMsg = sim.pointstat;
        var msg = eval("(" + jMsg + ")");
        var msgmatchs = eval("(" + sim.matchhispa + ")");
        //var msgmatchs = eval("(" + sim.matchhispa + ")");
        showInfo(msg);
        showMatchHis(msgmatchs);

    }
    else {
        //JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"排行榜\"}');
        //JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"成绩详情\"}');
        requestServer("Exam/GetUserPointStat", "gamecode=" + app.gamecode);
        requestServer("Exam/GetUserMatchHis2", "gamecode=" + app.gamecode);
    }
}

function showMatchHis(msg) {
    //myVue.pageTitle = new Array();
    //myVue.pageTitle[0] = '我的战绩';
    //myVue.items[0] = new Array();
    for (var i = 0; i < msg.info.matchs.length; i++) {
        app.matchs.push({
            type: getGameName(app.gamecode),
            gamecode: app.gamecode,
            time: msg.info.matchs[i].datetime,
            score: msg.info.matchs[i].score,
            r: msg.info.matchs[i].r,
            midx: msg.info.matchs[i].midx,
            nickname: msg.info.matchs[i].nickname
        });
        //myVue.items[0][i].type = getGameName(msg.info.matchs[i].gamecode);
        //myVue.items[0][i].time = msg.info.matchs[i].datetime;
        //myVue.items[0][i].value = msg.info.matchs[i].score;
    }
}

function showhis() {
    //var gamecode = GetQueryString("gamecode");
    window.location.href = "matchhis.html?gamecode=" + app.gamecode;
}

function showInfo(msg) {
    // 指定图表的配置项和数据
    var option = {
        title: {
            text: ''
        },
        tooltip: {
            trigger: 'axis'
        },
        legend: {
            data: ['我的', '平均分'],
            left: 'right',
            top: 32
        },
        grid: {
            left: '5%',
            right: '8%',
            bottom: '3%',
            top: 80,
            containLabel: true
        },
        toolbox: {
            feature: {
                //saveAsImage: {}
            }
        },
        xAxis: {
            type: 'category',
            boundaryGap: false,
            data: []
        },
        yAxis: {
            type: 'value'
        },
        series: [
            //{
            //    name: '最高分',
            //    type: 'line',
            //    data: [120, 132, 101, 134, 90, 230, 210]
            //},
            //{
            //    name: '平均分',
            //    type: 'line',
            //    data: [220, 182, 191, 234, 290, 330, 310]
            //},
            //{
            //    name: '最低分',
            //    type: 'line',
            //    data: [150, 232, 201, 154, 190, 330, 410]
            //}
        ]
    };
    var myChart = echarts.init(document.getElementById('main'));
    var seqs = [];
    var mys = [];
    var avgs = [];

    seqs.push(0);
    mys.push(0);
    avgs.push(0);

    for (var i = 0; i < msg.info.stat.length; i++) {
        var ex = msg.info.stat[i];
        seqs.push('前' + (i + 1) + '场');
        avgs.push(avgs[i] + ex.avg);
        mys.push(mys[i] + ex.my)
    }
    option.xAxis.data = seqs;
    option.series.push({ name: '我的', type: 'line', data: mys });
    option.series.push({ name: '平均分', type: 'line', data: avgs });

    option.title.text = '比赛累积获得积分--' + msg.info.gamename;

    // 使用刚指定的配置项和数据显示图表。
    myChart.setOption(option);
}

function onGameNativeMsg(source, msg) {

    switch (source) {
        case 'server':
            switch (msg.request) {
                case 'GetUserPointStat':
                    showInfo(msg);
                    break;
                case 'GetUserMatchHis2':
                    showMatchHis(msg);
                    break;
            }
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    var nextAction = GetQueryString("nextaction");
                    if (nextAction == "back") {
                        window.history.back();
                    }
                    else if (nextAction == "my") {
                        window.location.href = "my.html";
                    }
                    else if (nextAction == "exit") {
                        JavaScriptInterface.nativeCommand('exit', '');
                    }
                    else {
                        window.location.href = "myscore.html";
                    }                    
                    break;
                default:
                    break;
            }
            break;
    }
}

