﻿$(document).ready(function () {
    if (isSimulation) {
        getInfo();
    }
    else {
        //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"gettoken()\"}');
        JavaScriptInterface.nativeCommand('getToken', '');
    }
});


function getInfo() {
    if (isSimulation) {
        var jMsg = sim.fblist;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    requestServer("Feedback/List");
}

function showInfo(msg) {

    JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"留言和提问\"}');

    $("#list li").remove();
    for (var i = 0; i < msg.info.ls.length; i++) {
        var ex = msg.info.ls[i];
        var text = '<li><a href="fbdetail.html?idx=' + ex.Idx + '">';
        var title = ex.Title + '...';
        if (ex.Status == 1) {
            title = '[已回复] ' + title;
        }
        text = text + title + "</a><i>";
        $("#list").append(text).trigger('create');
    }
}


// JavaScript source code
function onNativeMsg(source, jMsg) {
    var msg = eval("(" + jMsg + ")");
    //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case 'server':

            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                showInfo(msg);
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    window.location.href = "my.html";
                    break;
                case 223:
                case '223':
                case '223.0':
                    token = msg.info;
                    getInfo();
                    // initStepTwo();
                    break;
                default:
                    break;
            }
    }
}