﻿"use strict";

var app = new Vue({
    el: "#app",
    data: {
        init: false,
        time: 20,
        timeText: "",
        waituser: 3,
        style: ""
    },
    components: {},
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "min-height: " + this.height + "px";
    },
    computed: {},
    methods: {
        // 倒计时
        timer: function timer() {
            console.log("getinfo");
            getInfo();

        }
    },
    created: function created() { },
    mounted: function mounted() {
        this.init = true;
        //this.timer();
    }
});

function getInfo() {
    SetTitle("打分等待");
    if (isSimulation) {
        var jMsg = sim.appfive;
        var msg = eval("(" + jMsg + ")");
        dealInfo(msg);
    } else if (token) {
        requestServer("GamePA/GetMatchStatusInfo");
    }
}

function dealInfo(msg) {
    if (msg.info.stage == 6) {
        window.location.href = "six.html";
    } else {
        app.waituser = msg.info.waituser;
        setTimeout(app.timer, 1000);
    }
} // JavaScript source code

function onGameNativeMsg(source, msg) {
    //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case "server":
            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                //if (msg.request == "GetMatchStatusInfo")
                dealInfo(msg);
            }

            break;

        case "peer":
            break;

        case "system":
            switch (msg.code) {
                case 220:
                case "220":
                case "220.0":
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    //JavaScriptInterface.nativeCommand("exit", ""); //window.location.href = "my.html";
                    MsgBox('提示', '比赛进行中，无法退出！');

                    break;
                //case 223:
                //case '223':
                //case '223.0':
                //    token = msg.info;
                //    getInfo();
                //    // initStepTwo();
                //    break;

                case 225:
                case "225":
                case "225.0":
                    break;

                case 230:
                case "230":
                case "230.0":
                    leave = true;
                    break;

                default:
                    break;
            }
    }
}
