﻿"use strict";

var app = new Vue({
    el: "#app",
    data: {
        init: false,
        style: "",
        inviteinput: "",
        invite: -1,
        invitecode: "",
        inviteuser: "",
        prompt: "　",
        items: [
            {
                label: "",
                time: "",
                star: 0
            }
        ]
    },
    components: {},
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "min-height: " + this.height + "px";
    },
    computed: {},
    methods: {
        copy: function copy() {
            copyinvitecode(this.invitecode);
        },
        bind: function bind() {
            useinvitecode();
        },
        tap: function tap() {
            console.log("tap");
        }
    },
    created: function created() { },
    mounted: function mounted() {
        this.init = true;
    }
});

function copyinvitecode(code) {
    if (isSimulation) {
        alert(code);
    } else {
        JavaScriptInterface.nativeCommand("copy", '{"text":"' + code + '"}'); //JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"领奖码：' + code + '已复制到剪贴板\"}');

        JavaScriptInterface.nativeCommand(
            "msgBox",
            '{"title":"提示","msg":"推荐码：' + code + '已复制到剪贴板","t":"3"}'
        );
    }
}

var flag = false;

function useinvitecode() {
    var code = app.inviteinput.replace(/\"/g, "").replace(/\'/g, "");

    if (code.length == 0) {
        MsgBox("提示", "请输入推荐码！");
        return false;
    }

    if (code == app.invitecode) {
        MsgBox("提示", "请输入推荐人的推荐码！");
        return false;
    }

    if (isSimulation) {
        var useInviteMsg = eval("(" + sim.inviteresult1 + ")");
        showBindResult(useInviteMsg);
    } else {
        if (flag == false) {
            flag = true;
            var code = app.inviteinput.replace(/\"/g, "").replace(/\'/g, "");
            requestServer("User/UseInviteCode", "code=" + code);
        }
    }
}

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.inviters;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
        var inviteMsg = eval("(" + sim.invite0 + ")");
        showInviteInfo(inviteMsg);
    } else {
        JavaScriptInterface.nativeCommand("setTitle", '{"title":"推荐"}');
        requestServer("User/GetInviteUserList");
        requestServer("User/GetInviteInfo");
    }
}

function showInviteInfo(msg) {
    app.invite = msg.info.invite;
    app.invitecode = msg.info.invitecode;
    app.inviteuser = msg.info.inviteuser;
}

function showBindResult(msg) {
    //err：0绑定，-1 邀请码无效，-2 邀请人晚于被邀请人注册
    if (msg.info.err == 0) {
        app.invite = 1;
        app.inviteuser = msg.info.inviteuser;
        app.prompt = "";
    } else if (msg.info.err == -1) {
        app.prompt = "推荐码无效，请重新输入";
    } else if (msg.info.err == -2) {
        app.prompt = "推荐码对应的推荐人比您更晚使用本APP"; //，推荐关系绑定失败
    }
    flag = false;
}

function showInfo(msg) {
    var items = [];

    for (var i = 0; i < msg.info.users.length; i++) {
        var ex = msg.info.users[i]; //var text = '<li><a href="fbdetail.html?idx=' + ex.Idx + '">';

        var title = "";

        switch (ex.level) {
            case 0:
                title = "TA升一星后，您将获得一张双倍券";
                break;

            case 1:
            case 2:
                title = "TA升三星后，您将获得一张双倍券";
                break;

            case 3:
                title = "TA升四星后，您将获得一张双倍券";
                break;

            case 4:
                title = "TA升五星后，您将获得一张双倍券";
                break;

            case 5:
                title = "TA已于" + ex.stardate + "获得五星！";
                break;

            default:
                break;
        } //text = text + title + "</a><i>";
        //$("#list").append(text).trigger('create');

        items.push({
            label: ex.nickname,
            star: ex.level,
            time: title
        });
    }

    for (var i = msg.info.users.length; i < 6; i++) {
        items.push({});
    }

    app.items = items; //app.invitecode = msg.info.invitecode;
} // JavaScript source code

function onGameNativeMsg(source, msg) {
    switch (source) {
        case "server":
            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                if (msg.request == "GetInviteUserList") {
                    showInfo(msg);
                } else if (msg.request == "GetInviteInfo") {
                    showInviteInfo(msg);
                } else if (msg.request == "UseInviteCode") {
                    showBindResult(msg);
                }
            }

            break;

        case "peer":
            break;

        case "system":
            switch (msg.code) {
                case 220:
                case "220":
                case "220.0":
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand("exit", ""); //window.location.href = "my.html";

                    break;

                default:
                    break;
            }
    }
}
