﻿$(document).ready(function () {
    if (isSimulation) {
        getInfo();
    }
    else {
        //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"gettoken()\"}');
        JavaScriptInterface.nativeCommand('getToken', '');
    }
});


function getInfo() {
    if (isSimulation) {
        var jMsg = sim.leaguerank;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }


    requestServer("League/GetGroupRank");
}

function showInfo(msg) {
    if (msg.info.joined == 0) {
        $(".opendate").html("您还没有参加过比赛活动");
        $(".updatetime").html("");
    }
    else {
        var title = msg.info.title;
        if (msg.info.showgroup == 1) {
            title = title + " 第" + msg.info.groupidx + "区";
        }

        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"' + title + '\"}');

        //$(".leaguetitle").html(msg.info.title);
        //$(".group").html("第" + msg.info.groupidx + "区");
        $(".opendate").html("活动周期：" + msg.info.startdate + " ~ " + msg.info.enddate);
        $(".updatetime").html("	更新时间：" + msg.info.updatetime);
        $("#ranks li").remove();
        for (var i = 0; i < msg.info.ranklist.length; i++) {

            var ex = msg.info.ranklist[i];
            var me = ex.me;
            var text = "";
            if (me) {
                text = '<li class="lv">';
            }
            else {
                text = '<li>';
            }

            text = text + "<i>";
            if (ex.totalpoint > 0) {
                text = text + ex.tmprank;
            }
            text = text + "</i>";
            if (ex.totalpoint > 0) {
                if (ex.tmprank == 1) {
                    text = text + '<div class="medal gold"></div>';
                }
                else if (ex.tmprank == 2) {
                    text = text + '<div class="medal silver"></div>';
                }
                else if (ex.tmprank == 3) {
                    text = text + '<div class="medal bronze"></div>';
                }
            }
            text = text + '<p>' + ex.totalpoint + ' ' + ex.nickname + '</p> ';

            if (msg.info.gametype == 1) {
                if (ex.upgrade == 1) {
                    text = text + '<span><img src="images/upgraded.png"></span>';
                }
                else if (ex.upgrade == -1) {
                    text = text + '<span><img src="images/degraded.png"></span>';
                }
            }
            else {
                if (ex.upgrade == 1) {
                    text = text + '<span><img src="images/knight.png" style = "height:21px; width:14px"></span>';
                }
            }

            if (ex.illegal > 0) {
                text = text + '<span><img src="images/yellow.png" style = "height:21px; width:14px"></span>';
            }
            text = text + "</li>";
            $("#ranks").append(text).trigger('create');
        }

    }
}

// JavaScript source code
function onNativeMsg(source, jMsg) {
    var msg = eval("(" + jMsg + ")");
    //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case 'server':

            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                showInfo(msg);
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand('exit', '');
                    break;
                case 223:
                case '223':
                case '223.0':
                    token = msg.info;
                    getInfo();
                    // initStepTwo();
                    break;
                default:
                    break;
            }
    }
}