﻿$(document).ready(function () {
    if (isSimulation) {
        getInfo();
    }
    else {
        //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"gettoken()\"}');
        JavaScriptInterface.nativeCommand('getToken', '');

    }
});


function getInfo() {

    if (isSimulation) {
        var jMsg = sim.leaguetoday;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    else {
        requestServer("League/GetLeagueToday");
    }
}

function showInfo(msg) {
    if (msg.info.groupidx == 0) {
        $(".leaguetitle").html(msg.info.title);
        $(".group").html("您今天还没有参加过比赛");
        $(".title").html("您今天还没有参加过比赛");
    }
    else {
        $(".leaguetitle").html(msg.info.title);
        if (msg.info.showgroup == 1) {
            $(".group").html("第" + msg.info.groupidx + "区");
        }
        else {
            $(".group").html("");
        }

        $("#ranks li").remove();
        for (var i = 0; i < msg.info.ranklist.length; i++) {
            var ex = msg.info.ranklist[i];
            var me = ex.me;
            var text = "";
            if (me) {
                text = '<li class="lv">';
            }
            else {
                text = '<li>';
            }
            var color = "";
            if (ex.point > 3)
                color = "c";
            else if (ex.point > 2)
                color = "h";
            else
                color = "l";

            text = text + '<i>' + ex.rank + '</i><span class="kuai ' + color + '">' + ex.point + '</span>'
                + ex.score + ' ' + ex.nickname + '</li > ';

            $("#ranks").append(text).trigger('create');
        }
        $("#matchs li").remove();
        for (var i = 0; i < msg.info.matchs.length; i++) {
            var ex = msg.info.matchs[i];
            var text = '<li><div class="mc">' + ex.score + ' ' + ex.rolea + ' - ' + ex.roleb + '</div><div class="sj">';
            if (ex.score == 0)
                text = text + '<span class="kuai h">x</span>';
            else
                text = text + ex.secformat;
            text = text + '</div></li>';

            $("#matchs").append(text).trigger('create');
        }
    }
}

// JavaScript source code
function onNativeMsg(source, jMsg) {
    var msg = eval("(" + jMsg + ")");
    //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case 'server':

            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                showInfo(msg);
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand('exit', '');
                    break;
                case 223:
                case '223':
                case '223.0':
                    token = msg.info;
                    getInfo();
                    // initStepTwo();
                    break;
                default:
                    break;
            }
    }
}