﻿$(document).ready(function () {
    if (isSimulation) {
        getInfo();
    }
    else {
        //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"gettoken()\"}');
        JavaScriptInterface.nativeCommand('getToken', '');

    }
});


function getInfo() {

    if (isSimulation) {
        var jMsg = sim.matchtoday;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    else {
        requestServer("Game/GetMatchsToday");
    }
}

function showInfo(msg) {
    if (msg.info.matchs.length == 0) {
        $(".title").html("您今天还没有参加过比赛");
    }
    else {
        $(".title").html("今天共参加比赛" + msg.info.matchs.length  + "次");

        $("#matchs li").remove();
        for (var i = 0; i < msg.info.matchs.length; i++) {
            var ex = msg.info.matchs[i];
            //<li><div class="mc">9485 胡子 - 我</div><div class="sj">2:30s</div></li>
            var text = '<li><div class="mc">';
            if (ex.gamecode.toUpperCase() == "PS2") {
                text = text + '[传图] ';
            }
            else if (ex.gamecode.toUpperCase() == "EC") {
                text = text + '[情绪] ';
            }

            text = text + ex.score + ' ' + ex.rolea + ' - ' + ex.roleb + '</div><div class="sj">';
            if (ex.score == 0)
                text = text + '<span class="kuai h">x</span>';
            else
                text = text + ex.secformat;
            text = text + '</div></li>';

            $("#matchs").append(text).trigger('create');
        }
    }
}

// JavaScript source code
function onNativeMsg(source, jMsg) {
    var msg = eval("(" + jMsg + ")");
    //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case 'server':

            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                showInfo(msg);
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand('exit', '');
                    break;
                case 223:
                case '223':
                case '223.0':
                    token = msg.info;
                    getInfo();
                    // initStepTwo();
                    break;
                default:
                    break;
            }
    }
}