﻿$(document).ready(function () {
    if (isSimulation) {
        getInfo();
    }
    else {
        //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"gettoken()\"}');
        JavaScriptInterface.nativeCommand('getToken', '');
        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"公告和消息\"}');
    }
});


function getInfo() {
    if (isSimulation) {
        var jMsg = sim.messages;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    
    requestServer("Message/List");
}

function showInfo(msg) {
    if (msg.info.results.length == 0) {
        $("#nojoin").show();
    }
    else {
        $("#nojoin").hide();
        $("#msgs li").remove();
        for (var i = 0; i < msg.info.results.length; i++) {
            var ex = msg.info.results[i];
            var text = "<li><a href='msginfo.html?idx=" + ex.idx + "&mtype=" + ex.mtype +"' >";
            if (ex.mtype == "N") {
                text = text + "[公告]";
            }
            //else {
            //    // M
            //    text = text + "[消息]";
            //}

            text = text + ex.title;
            if (ex.status == 1) {
                text = text + " 已读 ";
            }
            else {
                text = text + " <font color='yellow'>未读</font> ";
            }
            text = text + ex.date + "</a></li>";
            $("#msgs").append(text).trigger('create');
        }
        //$(".list").listview('refresh');
    }
}

// JavaScript source code
function onNativeMsg(source, jMsg) {
    var msg = eval("(" + jMsg + ")");
    //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case 'server':

            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                showInfo(msg);
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    //JavaScriptInterface.nativeCommand('exit', '');
                    //window.history.back();
                    window.location.href = "my.html";
                    break;
                case 223:
                case '223':
                case '223.0':
                    token = msg.info;
                    getInfo();
                    // initStepTwo();
                    break;
                default:
                    break;
            }
    }
}