﻿function getInfo() {
    if (isSimulation) {
        var jMsg = sim.messages;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    else {
        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"公告和消息\"}');
        requestServer("Message/List");
    }
}

function showInfo(msg) {
    var items = [];
    for (var i = 0; i < msg.info.results.length; i++) {
        var ex = msg.info.results[i];

        var text = "";
        var mtype = "M";
        if (ex.mtype == "N") {
            text = text + "[公告]";
            mtype = "N";
        }
        //else {
        //    // M
        //    text = text + "[消息]";
        //}

        text = text + ex.title;
        //if (ex.status == 1) {
        //    text = text + " 已读 ";
        //}
        //else {
        //    text = text + " <font color='yellow'>未读</font> ";
        //}
        items.push({ label: text, id: ex.idx, mtype: mtype, status: ex.status, date:ex.date });
    }
    app.items = items;
    app.init = true;
}

// JavaScript source code
function onGameNativeMsg(source, msg) {
    switch (source) {
        case 'server':

            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                showInfo(msg);
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand('exit', '');
                    //window.history.back();
                    //window.location.href = "my.html";
                    break;
                default:
                    break;
            }
    }
}