﻿function escape2Html(str) {
    var arrEntities = { 'lt': '<', 'gt': '>', 'nbsp': ' ', 'amp': '&', 'quot': '"' };
    return str.replace(/&(lt|gt|nbsp|amp|quot);/ig, function (all, t) { return arrEntities[t]; });
}

$(document).ready(function () {
    if (isSimulation) {
        var jMsg = sim.msginfo;

        //var msg = eval("(" + jMsg + ")");
        var msg = JSON.parse(jMsg); 
        showInfo(msg);
    }
    else {
        //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"gettoken()\"}');
        $("#nojoin").hide();

        JavaScriptInterface.nativeCommand('getToken', '');
        
    }
});

function getInfo() {
    //requestServer("Message/Read");
    var mtype = "M";
    if (GetQueryString("mtype") == "N") {
        requestServer("Message/Read", "idx=" + GetQueryString("idx") + "&mtype=N");
        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"公告详情\"}');
    }
    else {
        requestServer("Message/Read", "idx=" + GetQueryString("idx"));
        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"消息详情\"}');
    }

}

function showInfo(msg) {
    if (msg.info.msg == null || msg.info.msg == undefined) {
        $("#nojoin").show();
        $("#join").hide();
    }
    else {
        $("#join").show();
        $("#nojoin").hide();
        $("#title").html(msg.info.msg.title);
        $("#details").html(escape2Html(msg.info.msg.message));
        $("#date").html(msg.info.msg.date);
    }
}

// JavaScript source code
function onNativeMsg(source, jMsg) {
    var msg = eval("(" + jMsg + ")");
    //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case 'server':

            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                showInfo(msg);
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    //JavaScriptInterface.nativeCommand('exit', '');
                    //window.history.back();
                    window.location.href = "messages.html";
                    break;
                case 223:
                case '223':
                case '223.0':
                    token = msg.info;
                    getInfo();
                    // initStepTwo();
                    break;
                default:
                    break;
            }
    }
}