﻿$(document).ready(function () {
    //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"gettoken()\"}');
    JavaScriptInterface.nativeCommand('getToken', '');
    JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"个人详情\"}');
});

function getUserInfo() {
    requestServer("User/GetUserPointInfo");
}

function showUserInfo(msg) {
    $(".nickname").html(msg.info.nickname);
    $(".explevel").html("级 别：" + msg.info.userlevel);
    $(".exp").html(msg.info.currexp + '/' + msg.info.requireexp);
    $(".progress-bar").css("width", msg.info.currexp * 100.0 / msg.info.requireexp + "%");
    $(".credit").html(msg.info.credit);
    $(".gold").html(msg.info.gold);
    $(".prize").html(msg.info.certinfo);
    $(".area").html(msg.info.league);
    if (msg.info.msgcount > 0) {
        $("#msgdot").addClass("red_dot");
    }
    if (msg.info.certlevel < 0) {
        $("#prizedot").hide();
    }
    //$("#msgdoc").addClass("red_dot");
}

function getprize() {
    window.location.href = "prize.html";
}

function getcert() {
    window.location.href = "cert.html";
}

// JavaScript source code
function onNativeMsg(source, jMsg) {
    var msg = eval("(" + jMsg + ")");
    //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case 'server':
            
            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                showUserInfo(msg);
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand('exit', '');
                    break;
                case 223:
                case '223':
                case '223.0':
                    token = msg.info;                    
                    getUserInfo();
                    
                    // initStepTwo();
                    break;
                default:
                    break;
            }
    }
}