﻿"use strict";

var step = 3; //辩论

var app = new Vue({
  el: "#app",
  data: {
    init: false,
	audio: null,
    style: '',
    definfo: {
      matchidx: 0,
      title: "",
      description: "",
      description2: "",
      options: [{
        title: "",
        description: "",
        role: ""
      }, {
        title: "",
        description: "",
        role: ""
      }, {
        title: "",
        description: "",
        role: ""
      }, {
        title: "",
        description: "",
        role: ""
      }, {
        title: "",
        description: "",
        role: ""
      }],
      userrole: "",
      mptime: 30,
      dptime: 30
    },
    initdata: {
      matchidx: 0,
      stage: 4,
      micseq: [],
      mpos: 0,
      acount: 4,
      ncount: 1,
      players: [{
        role: "A",
        bacount: 1,
        bncount: 1,
        timeremain: 10
      }, {
        role: "B",
        bacount: 1,
        bncount: 1,
        timeremain: 10
      }, {
        role: "C",
        bacount: 1,
        bncount: 1,
        timeremain: 10
      }, {
        role: "D",
        bacount: 1,
        bncount: 1,
        timeremain: 10
      }, {
        role: "E",
        bacount: 1,
        bncount: 1,
        timeremain: 10
      }]
    },
    error: false,
    // 举报窗口
    inputReason: false,
    myreason: '',
    popup: false,
    popupdata: {
      title: '',
      body: ''
    },
    actionHintText: '',
    timerRun: true,
    maxtime: 0,
    // 最大时间
    time: 0,
    // 累计用时
    mic: {},
    // 当前发言
    user: {},
    //用户
    btnText: '',
    btnAction: true,
    speaking: false
//	exit: false
  },
  components: {},
  watch: {},
  beforeMount: function beforeMount() {
    // 获取数据
    this.height = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
    this.style = "min-height: ".concat(this.height, "px");
    this.audio = document.createElement("audio");
  },
  computed: {
    // 麦序背景
    maskPos: function maskPos() {
      return "width: ".concat(this.initdata.mpos * 40, "px");
    },
    // 主按钮
    Btn: function Btn() {
      var style = '';

      if (this.initdata.mpos > 0 || this.user.timeremain > 0) {
        //						var mypos = this.initdata.micseq.indexOf(this.definfo.userrole);
        var mypos = this.initdata.micseq.indexOf('我');

        if (mypos < 0) {
          style = 'talk green';
          this.btnText = '我要发言';
          this.actionHintText = '请申请发言，进入麦序';
        } else if (mypos == 0) {
          style = 'talk red';
          this.btnText = '停止发言';
          this.actionHintText = '您的发言已开始，按“停止发言”退出发言';
        } else if (mypos < this.initdata.mpos) {
          style = 'talk disabled';
          this.btnText = '我要发言';
          this.actionHintText = '稍后将轮到您立论发言，请等待';
        } else {
          style = 'talk green un';
          this.btnText = '取消发言';
          this.actionHintText = '点击“取消发言”，可退出麦序';
        }

        if (this.initdata.micseq.length == 0) {
          this.actionHintText = '无人发言，正在扣除剩余时间最长选手的用时';
        }

        this.btnAction = true;
      } else {
        style = 'talk disabled';
        this.btnText = '取消发言';
        this.btnAction = false;
        this.actionHintText = '您的发言时间已用完';
      }

      return style;
    },
	exit: function exit() {
		return this.initdata.mpos == 0 && this.initdata.micseq.indexOf('我') != 0 && this.user.timeremain > 0 && this.definfo.dptime - this.user.timeremain > 30;
	},
    // 弃按钮
/*    exit: function exit() {
      //                    return this.initdata.micseq.indexOf(this.definfo.userrole) != 0 && this.definfo.dptime - this.user.timeremain > 30 && this.user.timeremain > 0
      return this.initdata.micseq.indexOf('我') != 0 && this.definfo.dptime - this.user.timeremain > 30 && this.user.timeremain > 0;
    },*/
    // 圆环倒计时
    stroke: function stroke() {
      if (this.initdata.mpos == 0) {
        return "".concat(this.user.width * (-this.user.timeremain + this.definfo.dptime), " 142");
      } else if (this.initdata.mpos > 0) {
        return "".concat(this.user.width * (-this.user.timeremain + this.definfo.mptime), " 142");
      }
    },
    formatTime: function formatTime() {
      var minute = parseInt(this.user.timeremain / 60);
      var second = parseInt(this.user.timeremain % 60);
      var zero = function zero(v) {
        return v >> 0 < 10 ? "0".concat(v) : v;
      };

      return [zero(minute), zero(second)].join(':');
    }
  },
  methods: {
    // 举报
    tapMenu: function tapMenu() {
      this.error = !this.error;
      this.myreason = '';
	  this.inputReason = false;
    },
    tapReason: function tapReason() {
      this.inputReason = true;
    },
    // 获取最大时间
    getMaxTime: function getMaxTime() {
      var self = this;
      this.initdata.players.forEach(function (d) {
        if (d.timeremain > self.maxtime) {
          self.maxtime = d.timeremain;
        }
      });
    },
    // 更新当前麦
    getTimeremain: function getTimeremain() {
      var _this = this;
      var self = this;
      this.initdata.players.forEach(function (d) {
//        if (d.role == this.initdata.micseq[0]) {
        if (d.role == _this.initdata.micseq[0] || (d.role == _this.definfo.userrole && '我' == _this.initdata.micseq[0]) ) {
          self.mic = d;
        }
      });
    },
    // 标题
    defText: function defText(val) {
      var _this2 = this;

      var text = '';
      this.definfo.options.forEach(function (d) {
        if (d.role == val) {
          if (d.role == _this2.definfo.userrole) {
            text = '我. ' + "".concat(d.title);
          } else {
            text = "".concat(val, ". ").concat(d.title);
          }
        }
      });
      return text;
    },
    // 计时
    timer: function timer() {
      var self = this;

      if (this.initdata.micseq.length > 0) {
		if (this.mic.timeremain > 0) {
		  this.time++;
		  this.mic.timeremain--;
		  if('我' == myVue.initdata.micseq[0] && this.mic.timeremain == 10){
			app.audio.src = "./sound/ticks.mp3";
			app.audio.play();
		  }
		} else if ('我' == myVue.initdata.micseq[0]){
		  requestServer(apiCode, "GameAction", "act=23"); //结束发言
//		  sendPeerMsg('MatchStatusChanged');
		}
      } else {
        if (this.maxtime > 0) {
          var arr = this.initdata.players;
          this.maxtime--;
          this.time++;
          arr.forEach(function (d, idx) {
            if (d.timeremain > self.maxtime) {
              arr[idx].timeremain = self.maxtime;
            }
          });
        } else {
          requestServer(apiCode, "GetMatchStatusInfo");
        }
      }

      if (this.timerRun) {
        setTimeout(this.timer, 1000);
      }
    },
    //点击顶部图标
    tapTitle: function tapTitle() {
      this.popupdata = {
        title: this.definfo.title,
        body: this.definfo.description + this.definfo.description2
      };
      this.popup = true;
    },
    // 点击列表图标
    tapItem: function tapItem(idx) {
      this.popupdata = {
        title: "".concat(this.definfo.options[idx].role, ".").concat(this.definfo.options[idx].title),
        body: this.definfo.options[idx].description
      };
      this.popup = true;
    },
    tapZan: function tapZan() {
      requestServer(apiCode, "GameAction", "act=41");
//      sendPeerMsg('MatchStatusChanged'); //alert('赞')
    },
    tapCai: function tapCai() {
      requestServer(apiCode, "GameAction", "act=42");
//      sendPeerMsg('MatchStatusChanged'); //alert('差')
    },
    tapError: function tapError(reason) {
      this.error = false;
      this.inputReason = false; //                    alert('举报')
      //					requestServer("Game", "Report");

      if (reason != undefined) {
        requestServer("Game", "Report", "reason=" + reason);
      } else {
		if(this.myreason == ''){
			JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"请输入举报理由\",\"t\":\"3\"}');
		} else {
			requestServer("Game", "Report", "reason=" + this.myreason);
		}
      }
    },
    // 发言
    tapTalk: function tapTalk() {
      if (!this.btnAction) return; //alert(this.btnText)

      if (this.btnText == "我要发言") {
        requestServer(apiCode, "GameAction", "act=21"); //申请发言
      } else if (this.btnText == "取消发言") {
        requestServer(apiCode, "GameAction", "act=22"); //麦序中。取消发言			
      } else if (this.btnText == "停止发言") {
		app.audio.pause();
        requestServer(apiCode, "GameAction", "act=23"); //发言中。停止发言
        //						JavaScriptInterface.nativeCommand('micOff', '');
      }

//      sendPeerMsg('MatchStatusChanged');
    },
    // 弃
    tapExit: function tapExit() {
      requestServer(apiCode, "GameAction", "act=31");
//      sendPeerMsg('MatchStatusChanged'); //                    alert('弃')
    }
  },
  created: function created() {
    myVue = this;
  },
  mounted: function mounted() {
    var _this3 = this;

    this.init = true;
    var self = this; // 用户信息

    this.initdata.players.forEach(function (d) {
      if (d.role == _this3.definfo.userrole) {
        self.user = d;
        self.user.time = d.timeremain;
        self.user.width = 142 / (self.initdata.mpos > 0 ? self.definfo.mptime : self.definfo.dptime);
      }
    }); // 加载完成计时

    this.getTimeremain();
    this.getMaxTime();
    this.timer();
    setInterval(onHeartBeat, 20000);
  }
});

function requestInitInfo() {
  requestServer(apiCode, "GetInitInfo");
  requestServer(apiCode, "GetMatchStatusInfo");

  if (isSimulation) {
    onGameNativeMsg('server', {
      "request": "GetMatchStatusInfo",
      "info": {
        "stage": 4,
        "micseq": ['A','B','C'],
        "mpos": 0,
        "acount": 4,
        "ncount": 1,
        "players": [{
          "role": "A",
          "bacount": 1,
          "bncount": 0,
          "timeremain": 30
        }, {
          "role": "B",
          "bacount": 0,
          "bncount": 1,
          "timeremain": 30
        }, {
          "role": "C",
          "bacount": 2,
          "bncount": 0,
          "timeremain": 30
        }, {
          "role": "D",
          "bacount": 1,
          "bncount": 0,
          "timeremain": 15
        }, {
          "role": "E",
          "bacount": 0,
          "bncount": 0,
          "timeremain": 30
        }]
      }
    });
    onGameNativeMsg('server', {
      "request": "GetInitInfo",
      "info": {
        "matchidx": 551,
        "title": "年终福利",
        "description": "快到年终了...",
        "description2": "最终会...",
        "options": [{
          "title": "旅游度假",
          "description": "",
          "role": "A"
        }, {
          "title": "温泉",
          "description": "a",
          "role": "B"
        }, {
          "title": "烧烤",
          "description": "a",
          "role": "C"
        }, {
          "title": "西餐",
          "description": "a",
          "role": "D"
        }, {
          "title": "现金",
          "description": "a",
          "role": "E"
        }],
        "userrole": "A",
        "mptime": 30,
        "dptime": 120
      }
    });
  }
}

function onHeartBeat() {
  requestServer(apiCode, "GetMatchStatusInfo");
}

function updateParams() {
	for (var i = 0; i < myVue.initdata.micseq.length; i++) {
		if (myVue.initdata.micseq[i] == myVue.definfo.userrole) {
			myVue.initdata.micseq[i] = "我";
		}
	}

    myVue.user.width = 142 / (myVue.initdata.mpos > 0 ? myVue.definfo.mptime : myVue.definfo.dptime);

	myVue.getTimeremain();
	myVue.getMaxTime();

	if ('我' == myVue.initdata.micseq[0]) {
		JavaScriptInterface.nativeCommand('micOn', '');
		if (!myVue.speaking) {
			myVue.speaking = true;
			myVue.audio.src = "./sound/ready.mp3";
			myVue.audio.play();
			sendPeerMsg("MatchStatusChanged");
		}
	} else {
		JavaScriptInterface.nativeCommand('micOff', '');
		myVue.speaking = false;
	} 
}


function onGameNativeMsg(source, msg) {
  switch (source) {
    case 'server':
      switch (msg.request) {
        case 'GameAction':
	      sendPeerMsg('MatchStatusChanged');
        case 'GetMatchStatusInfo':
          switch (msg.info.stage) {
            case 4:

			  //如发言结束前，因服务器不同步返回了"发言结束"状态（无机会请求GameAction 23），则通知其他人更新状态
			  if(msg.request == "GetMatchStatusInfo" && myVue.speaking && '我' != msg.info.micseq[0]) {
				sendPeerMsg("MatchStatusChanged");
			  }
			  
              myVue.initdata.micseq = msg.info.micseq;
              myVue.initdata.mpos = msg.info.mpos;
              myVue.initdata.acount = msg.info.acount;
              myVue.initdata.ncount = msg.info.ncount;
              myVue.user.width = 142 / (myVue.initdata.mpos > 0 ? myVue.definfo.mptime : myVue.definfo.dptime);

              for (var i = 0; i < msg.info.players.length; i++) {
                myVue.initdata.players[i].bacount = msg.info.players[i].bacount;
                myVue.initdata.players[i].bncount = msg.info.players[i].bncount;
                myVue.initdata.players[i].timeremain = msg.info.players[i].timeremain;

                if (myVue.initdata.players[i].role == myVue.definfo.userrole) {
                  myVue.user.time = msg.info.players[i].timeremain;
                }
              }

			  updateParams();

              break;

            case 5:
              app.timerRun = false;
              window.location.href = "four.html";
              JavaScriptInterface.nativeCommand('micOff', '');
              break;
          }

          break;

        case 'GetInitInfo':
          //			myVue.definfo.title = msg.info.title;
          document.getElementById("title").innerHTML = msg.info.title;
          myVue.definfo.description = msg.info.description;
          myVue.definfo.description2 = msg.info.description2;

          for (var i = 0; i < msg.info.options.length; i++) {
            myVue.definfo.options[i].title = msg.info.options[i].title;
            myVue.definfo.options[i].description = msg.info.options[i].description;
            myVue.definfo.options[i].role = msg.info.options[i].role;
          }

          myVue.definfo.mptime = msg.info.mptime;
          myVue.definfo.dptime = msg.info.dptime;
          myVue.definfo.userrole = msg.info.userrole;
          myVue.initdata.players.forEach(function (d) {
            if (d.role == msg.info.userrole) {
              myVue.user = d;
            }
          });
		  
		  //如果GetMatchStatusInfo应答已先期收到，重新计算参数，开始发言（如麦序为0）
		  if(myVue.initdata.micseq != []){
			updateParams();
		  }
		  
          break;

        case 'Report':
          JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"服务器已收到举报\",\"t\":\"3\"}');
          break;
      }

      break;

    case 'peer':
      switch (msg.type) {
        case 'MatchStatusChanged':
          requestServer(apiCode, "GetMatchStatusInfo");
          break;
      }

      break;

    case 'system':
      switch (msg.code) {
        case 232:
        case '232':
        case '232.0':
          requestServer(apiCode, "GameAction", "act=52");
//          sendPeerMsg('MatchStatusChanged');
          break;

        case 233:
        case '233':
        case '233.0':
          requestServer(apiCode, "GameAction", "act=51");
          break;
      }

  }
}