"use strict";

var step = 2; //准备辩论

var app = new Vue({
  el: "#app",
  data: {
    init: false,
    time: 30,
    timeText: "",
    promptText: "倒数计时结束，比赛正式开始",
    style: "",
    userrole: "",
    title: "",
    desc: ""
  },
  components: {},
  watch: {},
  beforeMount: function beforeMount() {
    // 获取数据
    this.height = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
    this.style = "min-height: ".concat(this.height, "px");
    var t = window.location.href.split("=")[1];

    if (t != undefined) {
      if (t == 0) {
        this.promptText = "即将返回比赛";
        this.time = 3;
      } else {
        this.time = t;
      }
    }
  },
  computed: {},
  methods: {
    // 倒计时
    timer: function timer() {
      if (this.time > 0) {
        this.time--;
        this.timeText = this.time < 10 ? "0".concat(this.time) : "".concat(this.time);
        setTimeout(this.timer, 1000);
      } else {
        //          alert('倒计时结束')
        window.location.href = "pa_three.html";
      }
    }
  },
  created: function created() {
    myVue = this;
  },
  mounted: function mounted() {
    this.init = true;
    this.timer();
  }
});
var inroom = false;

function requestInitInfo() {
  requestServer(apiCode, "GetInitInfo");

  if (isSimulation) {
    onGameNativeMsg("server", {
      "code": 200,
      "request": "GetInitInfo",
      "info": {
        "matchidx": 23860,
        "title": "海上救援",
        "description": "寒冷的冬天，海水冰冷刺骨。海难后，一游艇上有五名游客等待救援，但是救援直升飞机每次只能够救一个人。游艇不停漏水，随时有沉没的危险。在游艇上待得越久风险越大。  游客情况：  1.将军，男，69岁，身经百战，曾为国家立下汗马功劳；  2.外科医生，女，41岁，医术高明，医德高尚；  3.大学教授，男，50岁，正主持一个有望将电池容量提高200%的科研项目；  4.运动员，女，23岁，奥运金牌获得者；  5.经理人，男，45岁，擅长经营管理，曾将一大型企业扭亏为盈；  请将这五名游客按照营救的先后顺序排序。",
        "description2": "",
        "users": [{
          "nickname": "胡昕",
          "role": "A"
        }, {
          "nickname": "chenlan",
          "role": "B"
        }, {
          "nickname": "CHEN QING",
          "role": "C"
        }, {
          "nickname": "David2",
          "role": "D"
        }, {
          "nickname": "丁丁丁柚嘉",
          "role": "E"
        }],
        "userrole": "B",
        "mptime": 30,
        "dptime": 45,
        "totaltime": 200
      }
    });
    /*    onGameNativeMsg("server", {
          code: 200,
          request: "GetInitInfo",
          info: {
            matchidx: 22715,
            title: "商务谈判",
            description:
              "公司总经理张总接到代理商的电话，有西班牙客户要购买500万美元的本公司产品，但必须在第二天派最多两人飞往北京谈判，对方不会中文和英语。但公司无销售可派，能临时上阵的只有:|研发主管|公关主管|财务经理|法务主管|英语翻译|客服主管|采购经理，请你们讨论选择两人前往。",
            description2: "",
            users: [
              {
                nickname: "david3",
                role: "A"
              },
              {
                nickname: "David2",
                role: "B"
              },
              {
                nickname: "胡昕",
                role: "C"
              }
            ],
            userrole: "B",
            mptime: 30,
            dptime: 30,
            totaltime: 600
          }
        });*/
  }
}

function onGameNativeMsg(source, msg) {
  switch (source) {
    case "server":
      switch (msg.request) {
        case "GetInitInfo":
          app.title = msg.info.title;
          document.getElementById("desc").innerHTML = "议题内容：" + msg.info.description.replace(/\|/g, "<br>") + "<br>" + msg.info.description2.replace(/\|/g, "<br>");
          app.userrole = msg.info.userrole;

          if (!inroom) {
            JavaScriptInterface.nativeCommand("createRoom", '{"name":"' + matchidx + '"}');
          }

          break;
      }

      break;

    case "system":
      switch (msg.code) {
        case 226:
        case "226":
        case "226.0":
          JavaScriptInterface.nativeCommand("joinRoom", '{"name":"' + matchidx + '"}');
          break;

        case 227:
        case "227":
        case "227.0":
          doExit("创建聊天室失败！");
          break;

        case 228:
        case "228":
        case "228.0":
          requestServer("Game", "SubmitChannelId", "channelid=" + msg.info);
          inroom = true;
          JavaScriptInterface.nativeCommand("micOff", "");
          break;

        case 229:
        case "229":
        case "229.0":
          doExit("加入聊天室失败！");
          break;

        case 232:
        case "232":
        case "232.0":
          requestServer(apiCode, "GameAction", "act=52");
          break;

        case 233:
        case "233":
        case "233.0":
          requestServer(apiCode, "GameAction", "act=51");
          break;
      }

  }
}