﻿$(document).ready(function () {
    if (isSimulation) {
        getInfo();
    }
    //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"gettoken()\"}');
    JavaScriptInterface.nativeCommand('getToken', '');

});


function getInfo() {

    if (isSimulation) {
        var jMsg = sim.rank;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    else {
        requestServer("User/GetTopExpRanks");
    }
}

function showInfo(msg) {

    $(".nickname").html(msg.info.myinfo.nickname);
    if (msg.info.myinfo.exp == 0)
        $("#ranking").html('未上榜');
    else
        $("#ranking").html('第' + msg.info.myinfo.rank + '名');
    $("#level").html(msg.info.myinfo.explevel);

    $.each(msg.info.list, function (no, p) {
        var user = p.nickname;
        if (p.exp == 0)
            return false;
        //        if (!p.me) {
        //            user = '<font class="blacktext">' + user + '</font>';
        //        }
        //        var txt = '<p class="rankp"><span>' + p.rank + '&emsp;' + user + '</span>' + p.explevel + '</p>';
        if (!p.me) {
            var txt = '<p class="rankp blacktext"><span>' + '<span class="boldtext">' + p.rank + '</span>&emsp;' + user + '</span>' + p.explevel + '</p>';
        } else {
            var txt = '<p class="rankp"><span>' + '<span class="boldtext">' + p.rank + '</span>&emsp;' + user + '</span>' + p.explevel + '</p>';
        }
        $("#main").append(txt);
    });

    //$(".list").listview('refresh');

}

// JavaScript source code
function onNativeMsg(source, jMsg) {
    var msg = eval("(" + jMsg + ")");
    //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case 'server':

            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                showInfo(msg);
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand('exit', '');
                    break;
                case 223:
                case '223':
                case '223.0':
                    token = msg.info;
                    getInfo();
                    // initStepTwo();
                    break;
                default:
                    break;
            }
    }
}