function getGameName(gamecode) {
    switch (gamecode) {
        case 'PS2S': return '沟通成本';
        case 'PS2C': return '说人话';
        case 'PA': return '有效说服';
        case 'PAN': return '面试沟通';
        case 'PAM': return '面试沟通';
        case 'EC': return '情绪练习';
    }
    return "其它";
}

function getInfo() {
    app.gamecode = GetQueryString("gamecode");
    if (app.gamecode == null || app.gamecode == undefined)
        app.gamecode = "";

    SetTitle("练习成绩");
    if (isSimulation) {
        var jMsg = sim.pointstat;
        var msgmatchs = eval("(" + sim.matchhisall + ")");
        showMatchHis(msgmatchs);
    }
    else {
        //JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"排行榜\"}');
        //JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"成绩详情\"}');
        //requestServer("Exam/GetUserPointStat", "gamecode=" + app.gamecode);
        requestServer("Exam/GetUserMatchHis2", "gametype=0&gamecode=" + app.gamecode);
    }
}

function showMatchHis(msg) {
    //myVue.pageTitle = new Array();
    //myVue.pageTitle[0] = '我的战绩';
    //myVue.items[0] = new Array();
    for (var i = 0; i < msg.info.matchs.length; i++) {
        app.matchs.push({
            type: getGameName(msg.info.matchs[i].gamecode),
            gamecode: msg.info.matchs[i].gamecode,
            time: msg.info.matchs[i].datetime,
            score: msg.info.matchs[i].score,
            r: msg.info.matchs[i].r,
            midx: msg.info.matchs[i].midx,
            nickname: msg.info.matchs[i].nickname
        });
        //myVue.items[0][i].type = getGameName(msg.info.matchs[i].gamecode);
        //myVue.items[0][i].time = msg.info.matchs[i].datetime;
        //myVue.items[0][i].value = msg.info.matchs[i].score;
    }
}

function onGameNativeMsg(source, msg) {

    switch (source) {
        case 'server':
            switch (msg.request) {
                case 'GetUserMatchHis2':
                    showMatchHis(msg);
                    break;
            }
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    var nextAction = GetQueryString("nextaction");
                    if (nextAction == "back") {
                        window.history.back();
                    }
                    else if (nextAction == "my") {
                        window.location.href = "my.html";
                    }
                    else if (nextAction == "exit") {
                        JavaScriptInterface.nativeCommand('exit', '');
                    }
                    else {
                        window.location.href = "myscore.html";
                    }                    
                    break;
                default:
                    break;
            }
            break;
    }
}

