﻿$(document).ready(function () {
    if (isSimulation) {
        getInfo();
    }
    else {
        JavaScriptInterface.nativeCommand('getToken', '');
        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"个人账号\"}');
        JavaScriptInterface.nativeCommand('getVersion', '');
    }
});

function logout() {
    requestServer("Account/Logout");
}

function submit() {
    var username = $("#username").val();
    var nickname = $("#nickname").val();
    var gender = $("input[name='sex']:checked").val();

    username = username.replace(/\"/g, "").replace(/\'/g, "");
    nickname = nickname.replace(/\"/g, "").replace(/\'/g, "");
    //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"' + username + '\"}');
    
    if (username.length == 0 || username == '请输入真实姓名') {
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"请输入真实姓名！\",\"t\":\"3\"}');
        return false;
    }
    if (nickname.length == 0 || nickname == '请输入昵称') {
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"请输入昵称！\",\"t\":\"3\"}');
        return false;
    }
    if (gender == undefined) {
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"请选择性别！\",\"t\":\"3\"}');
        return false;
    }

    var postinfo = '{"username": "' + username + '", "gender": ' + gender + ',"nickname": "' + nickname + '"}';
    requestServer("User/UpdateDetailSimple", "", postinfo);
}

function getInfo() {
    if (isSimulation) {

        var jMsg = sim.userinfo;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }


    requestServer("User/GetDetail");
}

function showInfo(msg) {
    $("#nickname").val(msg.info.nickname);
    $("#username").val(msg.info.username);
    $("input[type=radio][name='sex'][value=" + msg.info.gender + "]").attr("checked", 'checked');


}

// JavaScript source code
function onNativeMsg(source, jMsg) {
    var msg = eval("(" + jMsg + ")");
    //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case 'server':

            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                if (msg.request == "GetDetail")
                    showInfo(msg);
                else if (msg.request == "UpdateDetailSimple") {
                    JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"更新成功！\",\"t\":\"3\"}');
                    window.location.href = "my.html";
                }
                else if (msg.request == "Logout") {
                    JavaScriptInterface.nativeCommand('logout', '');
                }
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    //JavaScriptInterface.nativeCommand('exit', '');
                    //window.history.back();
                    window.location.href = "my.html";
                    break;
                case 223:
                case '223':
                case '223.0':
                    token = msg.info;
                    getInfo();
                    // initStepTwo();
                    break;
                case 225:
                case '225':
                case '225.0':
                    $("#version").html(msg.info);
                    break;
                default:
                    break;
            }
    }
}