/*
 * Game PS version 2.15 (Dec 18, 2018)
 */

var debug = false;
var isSimulation = false;

var base = "api/";
//var base = 'http://api.66ztc.cn/api/';
//var base = 'http://123.206.177.195:8001/api/';
var apiCode = "GamePS2";
var gameName = "传图";
var mainPage = "board-page";

var currentMsg;
var initMsg = null;
var finishMsg = null;
var lastMoveMsg = null;
var points = 10000;
var resendCount;
var targetbackground_i = 0;

//Level options, see onInit for details
var backgroundOption = 0;
var blockShowOption = 0;
var blockMoveOption = 0;
//var voiceOption = 0;			//0 - duplex, 1 - simplex

var focusBlock = null;
var blockBeingRotated = null;  // The DOM image currently being rotated (if any)
var blockBeingTranslated = null;  // The DOM image currently being translated (if any)
var mouseStartAngle = false;    // The angle of the mouse relative to the image centre at the start of the rotation
var mouseStartX = false;
var mouseStartY = false;
//var toolBeingSized = null;

var DegPergrid; 
var RadPerGrid;
var	maxzindex = 10;
var	deadzindex = 10;
var textPoints;

var countdown = 12;
var step = 0;
var lastX, lastY
var lastAngle = 0;
var currentTime, thinkTime, moveTime, currentAction, commentIdx;

var timerRightPos;
var rightPositionDisplayed = false;

var workBoard, targetBoard;
var isLargeTargetBoard = false;
var currentBG = 0;
var currentBackgroundFile, correctBackgroundFile;

//var tellerQuitReasons = ["看不到也听不到对方的反馈"];
//var listenerQuitReasons = ["完全听不到对方声音","听不清对方声音","物件无法移动","物件始终移不到位"];

//only for test simulation
if(isSimulation){

	var JavaScriptInterface = null;
	var moveMsg = null;
	var lastMsg = null;

/*	var lastString = '{"finished": true, "score": 6153.0, "totalscore":11232.0, "time": 96450.0, "steps": 91.0, "next": 3.0, "finishtime": "2017-04-27 16:30:00", record: {"score": 5010, "date": "2018-05-23T20:38"}, records: [{"score": 5010, "users": ["小李", "Mary"]}, {"score": 6010, "users": ["张三", "李四"]} ],\
	"targetshapes":\
	[{ "shapeid": 1, "angle": 0, "posx": 10, "posy": 4},\
	 { "shapeid": 2, "angle": 90, "posx": 10, "posy": 8},\
	 { "shapeid": 3, "angle": 0, "posx": 10, "posy": 12} ]	}';*/
	var lastString = '{"score": 6153.0, "next": 2.0, "targetbackgroundidx": 5, "finalpos":\
	[{"x":-1,"y":15,"angle":90,"id":1},\
	{"x":3,"y":15,"angle":90,"id":2},\
	{"x":7,"y":15,"angle":90,"id":3}],\
	"targetshapes":\
	[{ "shapeid": 1, "angle": 0, "posx": 10, "posy": 4},\
	 { "shapeid": 2, "angle": 90, "posx": 10, "posy": 8},\
	 { "shapeid": 3, "angle": 0, "posx": 10, "posy": 12} ]	}';
	var simSteps = 	[ '{"id": 1, "x": 5, "y": 3, "angle": 90, "score":800}',
					'{"id": 1, "x": 5, "y": 3, "angle": 0, "score":700}',
					'{"id": 2, "x": 10, "y": 8, "angle": 90, "score":600, isright: 1}',
					'{"id": 3, "x": 5, "y": 10, "angle": 90, "score":500}',
					'{"id": 3, "x": 5, "y": 10, "angle": 0, "score":400}',
					'{"id": 1, "x": 10, "y": 4, "angle": 0, "score":300, isright: 1}',
					'{"id": 3, "x": 10, "y": 12, "angle": 0, "score":200, isright: 1}' ];

	var moveString = '{"finished": false, "score": 300.0, "next": 0.0, }';

	var tellerInitString = '{"code": 200, "request": "GetInitInfo", "info":\
	{"countdown": 8812, "gridsize": 20, "anglesize": 24, "maxscore": 2000, "stepscore": 100, "bgscore": 500, "timescore": 10,\
	"level": 0, "backgrounds": [{ "bgidx": 1, "shapename": "bj001.jpg" }], "targetbackgroundidx": 1, "timelimit": 30,\
	"shapes":\
	[{ "shapeid": 1, "length": 2, "width": 6, "shapename": "rectangle_green.png" },\
	 { "shapeid": 2, "length": 2, "width": 6, "shapename": "rectangle_green.png" },\
	 { "shapeid": 3, "length": 2, "width": 6, "shapename": "rectangle_green.png" } ],\
	"initshapes":\
	[{ "shapeid": 1, "angle": 90, "posx": -1, "posy": 15},\
	 { "shapeid": 2, "angle": 90, "posx": 3, "posy": 15},\
	 { "shapeid": 3, "angle": 90, "posx": 7, "posy": 15} ],\
	"targetshapes":\
	[{ "shapeid": 1, "angle": 0, "posx": 10, "posy": 4},\
	 { "shapeid": 2, "angle": 90, "posx": 10, "posy": 8},\
	 { "shapeid": 3, "angle": 0, "posx": 10, "posy": 12} ]\
	}}';

	var listenerInitString = '{"code": 200, "request": "GetInitInfo", "info":\
	{"countdown": 8812, "rotate2grid":1, "gridsize": 20, "anglesize": 24, "maxscore": 2000, "stepscore": 100, "bgscore": 500, "timescore": 10, "timelimit": 30,\
	"level": 1, "backgrounds": [{ "bgidx": 1, "shapename": "bk.png" },{ "bgidx": 2, "shapename": "bj002.jpg" },{ "bgidx": 3, "shapename": "bj003.jpg" },{ "bgidx": 4, "shapename": "bj004.jpg" },{ "bgidx": 5, "shapename": "sample5.jpg" }],\
	"shapes":\
	[{ "shapeid": 1, "length": 2, "width": 6, "shapename": "rectangle_green.png" },\
	 { "shapeid": 2, "length": 2, "width": 6, "shapename": "rectangle_green.png" },\
	 { "shapeid": 3, "length": 2, "width": 6, "shapename": "rectangle_green.png" } ],\
	"initshapes":\
	[{ "shapeid": 1, "angle": 90, "posx": -1, "posy": 15},\
	 { "shapeid": 2, "angle": 90, "posx": 3, "posy": 15},\
	 { "shapeid": 3, "angle": 90, "posx": 7, "posy": 15} ]\
	}}';
}
//only for test simulation

var targetBoard;
var workBoard;

var protoBoard = {
	init: function(){

		document.oncontextmenu = function(){return false}
		document.onselectstart = function(){return false}
		document.ondragstart   = function(){return false}

//		document.ontouchmove = function(e){ e.stopPropagation(); e.preventDefault(); };
	},
	setBounds: function(divId, left, top, width, height, grids){
		this.boardDiv = document.getElementById(divId);
		this.boardDiv.style.left = left + 'px';
		this.boardDiv.style.top = top + 'px';
		this.boardDiv.style.width = width + 'px';
		this.boardDiv.style.height = height + 'px';
		this.gridSize = width/grids;
		this.ra2 = 0.013*screenWidth*screenWidth;			//r*r of the inner circle of the rotation ring
		this.rb2 = 0.04*screenWidth*screenWidth;			//r*r of the outer circle of the rotation ring
		this.rc2 = 0.09*screenWidth*screenWidth;			//r*r of the containing circle of external move handles
		this.gScale = 1.0;

		if(this.flag == 'movable'){
//			boardDiv.addEventListener("touchstart", root.onClientMouseMove, true);
			this.boardDiv.addEventListener("touchmove", protoBoard.onClientMouseMove, true);
			this.boardDiv.addEventListener("touchend", protoBoard.onClientMouseUp, true);
			this.boardDiv.addEventListener("mousemove", protoBoard.onClientMouseMove, true);
			this.boardDiv.addEventListener("mouseup", protoBoard.onClientMouseUp, true);
		}
	},
	getBounds: function(){
//		var rect = this.boardDiv.getBoundingClientRect();
		var rect = new Object();
		rect.left = parseInt(this.boardDiv.style.left);
		rect.top = parseInt(this.boardDiv.style.top);
		rect.width = parseInt(this.boardDiv.style.width);
		rect.height = parseInt(this.boardDiv.style.height);
		return rect;
	},
	resizeBounds: function(rect){
		this.gScale = this.gScale*rect.width/parseInt(this.boardDiv.style.width);
		
		this.boardDiv.style.left = rect.left + "px";
		this.boardDiv.style.top = rect.top + "px";
		this.boardDiv.style.width = rect.width + "px";
		this.boardDiv.style.height = rect.height + "px";

		//assume that the scale at the x axis is same as the scale at the y axis
//		this.gridSize = this.gridSize*gScale;

		for(var x in this.boardDiv.childNodes){
			//undefined means non "shape" object, such as the prompt div
			if(this.boardDiv.childNodes[x].father != undefined){
				var obj = this.boardDiv.childNodes[x].father;
//				obj.translateX = obj.translateX**this.gScale;
//				var xc = this.gScale*obj.width*this.gridSize/2;
//				var yc = this.gScale*obj.height*this.gridSize/2;
//				obj.div.style.transformOrigin = xc + "px " + yc + "px";  
//				obj.div.style.msTransformOrigin = xc + "px " + yc + "px"; 
//				obj.div.style.MozTransformOrigin = xc + "px " + yc + "px"; 
//				obj.div.style.webkitTransformOrigin = xc + "px " + yc + "px";   
//				obj.div.style.OTransformOrigin = xc + "px " + yc + "px"; 
				transformBlock(obj.div, obj.translateX, obj.translateY, obj.rotateAngle);
			}
		}
	},
	setBackground: function(url){
		this.boardDiv.style.backgroundImage = 'url('+url+')';
	},
	setFilter: function(filter){
//		this.boardDiv.style.backdropFilter = filter;
//		this.boardDiv.style.background = "filter(" + this.boardDiv.style.backgroundImage + ",'" + filter + "')";
	},
	createBlock: function(type, id, width, height, touchable){
		var z = new Block(type, width, height);
		z.id = id;
		z.board = this;
		z.init(touchable);
		this.boardDiv.appendChild(z.div);
		this.appList[id] = z;
		return z;
	},
	findBlock: function(id){
		for(var x in this.boardDiv.childNodes){
			//undefined means non "shape" object, such as the prompt div
			if(this.boardDiv.childNodes[x].father != undefined){
				if(this.boardDiv.childNodes[x].father.id == id){
					return this.boardDiv.childNodes[x].father;
				}
			}
		}
		return null;
	},

	appList  : {},
	boardDiv : null,
	gridSize : 10,
	ra2 : 0,
	rb2 : 0,
	rc2 : 0,

	onClientMouseUp: function(e){
		blockBeingRotated = null;
		blockBeingTranslated = null;
//		toolBeingSized = null;
		e.preventDefault();
	},
	onClientMouseMove: function(e){
		if(blockBeingTranslated != null){
			e.preventDefault();
			return blockBeingTranslated.onClientMouseMove(e);
		}else if(blockBeingRotated != null){
			e.preventDefault();
			return blockBeingRotated.onClientMouseMove(e);
//			}else if(toolBeingSized != null){
//				return toolBeingSized.onClientMouseMove(e);
		}else{
			document.body.style.cursor = 'default';
			return true;
		}
	}
};

function Board(flag){
	this.flag = flag;
}
Board.prototype.__proto__ = protoBoard;


var protoBlock = {
	init: function(touchable){
		this.div = new CreateComponentDIV(this.type);
		
		if(this.board.flag == "movable"){
			this.div.addEventListener("touchstart", this.div.onMyMouseDown, false);
			this.div.addEventListener("touchend", this.div.onMyMouseUp, false);
			this.div.addEventListener("mousedown", this.div.onMyMouseDown, false);
	//		z.addEventListener("mousemove", z.onMyMouseMove, false);
			this.div.addEventListener("mouseup", this.div.onMyMouseUp, false);
		}

		this.div.father = this;
		
		var w = this.width*this.board.gridSize;
		var h = this.height*this.board.gridSize;
		var xc = w/2;
		var yc = h/2;

		this.div.style.transformOrigin = xc + "px " + yc + "px";  
		this.div.style.msTransformOrigin = xc + "px " + yc + "px"; 
		this.div.style.MozTransformOrigin = xc + "px " + yc + "px"; 
		this.div.style.webkitTransformOrigin = xc + "px " + yc + "px";   
		this.div.style.OTransformOrigin = xc + "px " + yc + "px";

/*		if(touchable){
			this.div.innerHTML = '<img id="pic" style="position:absolute;" src="' + this.picture + '" width="' + w +'px" height="' + h +'px"/><img id="handle" style="position:absolute; visibility:hidden; opacity:0.1; left:' + (xc-0.3*screenWidth) + 'px; top:' + (yc-0.3*screenWidth) + 'px;" src="handle.png" width="' + 0.6*screenWidth + '"/>';
		} else {
			this.div.innerHTML = '<img id="pic" style="position:absolute;" src="' + this.picture + '" width="' + w +'px" height="' + h +'px"/>';	
		}
*/

		this.div.innerHTML = '<img id="pic" style="position:absolute;" src="' + this.picture + '" width="' + w +'px" height="' + h +'px"/>';
		
		if(touchable){
			this.divHTop = document.createElement('div');
			this.divHTop.innerHTML = '<img id="handle" style="position:absolute; opacity:0.1; left:' + (xc-0.2*screenWidth) + 'px; top:' + (yc-0.2*screenWidth) + 'px;" src="rotate_handle.png" width="' + 0.4*screenWidth + '"/><img id="handleT" style="position:absolute; opacity:0.1; left:' + (xc-0.05*screenWidth) + 'px; top:' + (yc-0.3*screenWidth) + 'px;" src="move_handle.png" width="' + 0.1*screenWidth + '"/><img id="handleB" style="position:absolute; opacity:0.1; left:' + (xc-0.05*screenWidth) + 'px; top:' + (yc+0.2*screenWidth) + 'px;" src="move_handle.png" width="' + 0.1*screenWidth + '"/><img id="handleL" style="position:absolute; opacity:0.1; left:' + (xc-0.3*screenWidth) + 'px; top:' + (yc-0.05*screenWidth) + 'px;" src="move_handle.png" width="' + 0.1*screenWidth + '"/><img id="handleR" style="position:absolute; opacity:0.1; left:' + (xc+0.2*screenWidth) + 'px; top:' + (yc-0.05*screenWidth) + 'px;" src="move_handle.png" width="' + 0.1*screenWidth + '"/>';
			this.divHTop.style.visibility = "hidden";
			this.div.appendChild(this.divHTop);
		}
		
		return this;
	},
	display: function(){
		this.div.style.visibility = "visible";
		return this;
	},
	hide: function(){
		this.div.style.visibility = "hidden";
		return this;
	},
	setLocation: function(x, y){
		//x, y are in scale of the screen width
//		var area = this.board.getBounds();
//		if(x < 0){x = gridRows + x;}
//		if(y < 0){y = gridRows + y;}
		x = parseFloat(x.toFixed(2));
		y = parseFloat(y.toFixed(2));
		lastX = x;
		lastY = y;
		this.translateX = x*this.board.gridSize;
		this.translateY = y*this.board.gridSize;
		transformBlock(this.div, this.translateX, this.translateY, this.rotateAngle);
		return this;
	},
	getLocation: function(){
//		return {x: this.translateX, y: this.translateY}
		var x = this.translateX/this.board.gridSize;
		var y = this.translateY/this.board.gridSize;
		x = parseFloat(x.toFixed(2));
		y = parseFloat(y.toFixed(2));
		return {x: x, y: y};
	},
	setAngle: function(ang){
//		var area = this.board.getBounds();
		ang = parseFloat(ang.toFixed(2));
		lastAngle = ang;
		this.rotateAngle = Math.PI*ang/180;
		transformBlock(this.div, this.translateX, this.translateY, this.rotateAngle);
		return this;
	},
	getAngle: function(){
//		return this.rotateAngle;
		var ang = this.rotateAngle*180/Math.PI;
		ang = parseFloat(ang.toFixed(2));
		return ang;
	},
//	reSize: function(scale){
//		this.width = this.width*scale;
//		this.height = this.height*scale;
//		this.translateX = this.translateX*scale;
//		this.translateY = this.translateY*scale;
//		transformBlock(this.div, this.translateX, this.translateY, this.rotateAngle);
//		return this;
//	},

	moveToTop: function(){
		this.div.style.zIndex = maxzindex++;
		return this;
	},
	setFilter: function(filter){
		this.div.style.filter = filter;
		return this;
	},
	
	width : 0,
	height : 0,
	id: 0,

//		setScale: function(scale){
//			if(scale > 2.0){
//				scale = 2.0;
//			}else if(scale < 0.5){
//				scale = 0.5
//			}
		
//			this.div.width = this.base_width*scale;			//reset the canvas with new width and height
//			this.div.height = this.base_height*scale;

//			this.scale = scale;
//			this.relative_scale = 1;

//			transformBlock(this.div, this.translateX, this.translateY, this.rotateAngle);

//			var area = root.getBounds();
//		},
//		getScale: function(scale){
//			return this.scale;
//		},
};

function Block(type, width, height){
	this.width = width;
	this.height = height;
	this.translateX = 0;
	this.translateY = 0;
	this.rotateAngle = 0;
//		this.scale = 1;
//		this.relative_scale = 1;
	this.type = 'block';
	this.picture = type;
	
	this.atRotateHandle = function(x, y, cx, cy){
		var d2 =(x-cx)*(x-cx) + (y-cy)*(y-cy);
		if(d2 < this.board.ra2){
			return 1;
		}else if(d2 < this.board.rb2){
			return 2;
		}else if(d2 < this.board.rc2){
			return 1;
		}else{
			return 0;
		}
	}

//		this.setScale(1);	//initial scale
}
Block.prototype.__proto__ = protoBlock;

function CreateComponentDIV(type){
//	var opacity = 0.8;

	var z = document.createElement('div');
//	z.width = width;
//	z.height = height;
	z.tabIndex = maxzindex;
	z.visibility = 'inherit';
	z.style.cssText = 'position:absolute; outline:none;';
//	z.style.opacity = 1.0;
	z.style.zIndex = maxzindex++;

	z.onMyMouseDown = function(e){
		
		if(gameover){
			return; //game has been over
		}
		
		if(!e){
			e = window.event; //IE
		}
		e.preventDefault();
		e.stopPropagation();

		//check Overlapping
		var onme,
			s = '',
			top,
			zIndexMax=-1,
			zIndex,
			offsetX,
			offsetY;

		if(e.type == "touchstart"){
			e = e.touches[0];
		}

		mouseStartX  = e.clientX;	//remember the position
		mouseStartY  = e.clientY;
		var pos = this.father.board.boardDiv.getBoundingClientRect();
		var centreX = pos.left + this.father.translateX + this.father.board.gridSize*this.father.width/2;
		var centreY = pos.top + this.father.translateY + this.father.board.gridSize*this.father.height/2;
//		var centreX = pos.left + (this.father.translateX + this.father.board.gridSize*this.father.width/2)*this.father.board.gScale;
//		var centreY = pos.top + (this.father.translateY + this.father.board.gridSize*this.father.height/2)*this.father.board.gScale;
		
		focusBlock = this;
		var atHandle = this.father.atRotateHandle(mouseStartX, mouseStartY, centreX, centreY);
		if(atHandle == 1){
			blockBeingTranslated = this;
			blockBeingRotated = null;
			prevX = this.father.translateX;
			prevY = this.father.translateY;
			currentAction = 1;
		} else if(atHandle == 2){
			blockBeingRotated = this;
			blockBeingTranslated = null;
			var mouseXFromCentre = e.clientX - centreX;
			var mouseYFromCentre = e.clientY - centreY;
			var mouseAngle = Math.atan2( mouseYFromCentre, mouseXFromCentre );
			mouseStartAngle = mouseAngle;
			currentAction = 2;
		} else {
			focusBlock = null;
		}
		
		for(var tool in this.father.board.appList){
			var currentBlock = this.father.board.appList[tool];
			zIndex = currentBlock.div.style.zIndex;
			if(zIndex>zIndexMax){
				top = tool;
				zIndexMax = zIndex;
			}
			currentBlock.div.lastChild.style.visibility = "hidden";
//			currentBlock.div.firstChild.nextSibling.style.visibility = "hidden";
			currentBlock.div.style.filter = 'brightness(100%)';

//			currentBlock.div.style.filter = 'grayscale(0%)';
//			currentBlock.div.style.opacity = 1.0;
			
			if(currentBlock != this.father){
				currentBlock.div.blur();
			}
//			if(currentBlock.inputarea){
//				currentBlock.inputarea.blur();
//			}
		}
		
		if(this.father.board.appList[top] != this.father){
			this.father.div.style.zIndex = maxzindex++;
		}
		
		//show the rotation handle (it is the second image at top of the block picture.
		this.lastChild.style.visibility = "visible";
//		this.firstChild.nextSibling.style.visibility = "visible";
		this.father.div.style.filter = 'brightness(110%)';

		var gameDate = new Date();
		var t = gameDate.getTime();
		thinkTime = t - currentTime;
		currentTime = t;
		
		var gridSize = this.father.board.gridSize;
		lastX = this.father.translateX/gridSize;
		lastY = this.father.translateY/gridSize;
		if(currentMsg.move2grid == 1){
			lastX = Math.round(this.father.translateX/gridSize);
			lastY = Math.round(this.father.translateY/gridSize);
		}
		
		lastAngle = DegPerGrid*this.father.rotateAngle/RadPerGrid;
		if(currentMsg.rotate2grid == 1){
			lastAngle = DegPerGrid*Math.round(this.father.rotateAngle/RadPerGrid);
		}

		return false;
	};

	z.onMyMouseUp = function(e){

		if(gameover){
			return; //game has been over
		}
		
		e.preventDefault();
		blockBeingRotated = null;
		blockBeingTranslated = null;
		step++;
		
		var gameDate = new Date();
		var t = gameDate.getTime();
		moveTime = t - currentTime;
		currentTime = t;
		var gridSize = this.father.board.gridSize;
		
		var msg = new Object();
		msg.step = step;
		msg.id = this.father.id;
		
		msg.x = this.father.translateX/gridSize;
		msg.y = this.father.translateY/gridSize;
		msg.x = parseFloat(msg.x.toFixed(2));
		msg.y = parseFloat(msg.y.toFixed(2));
		if(currentMsg.move2grid == 1){
			msg.x = Math.round(this.father.translateX/gridSize);
			msg.y = Math.round(this.father.translateY/gridSize);
		}
		
		msg.angle = DegPerGrid*this.father.rotateAngle/RadPerGrid;
		msg.angle = parseFloat(msg.angle.toFixed(2));
		if(currentMsg.rotate2grid == 1){
			msg.angle = DegPerGrid*Math.round(this.father.rotateAngle/RadPerGrid);
		}
		
		msg.thinkTime = thinkTime;
		msg.moveTime = moveTime;
		if( (currentAction == 1 && msg.x == lastX && msg.y == lastY) || (currentAction == 2 && msg.angle == lastAngle) ){
			msg.action = 0;
			currentAction = 0;
		} else {
			msg.action = currentAction;
			points = points - currentMsg.stepscore;
		}
		
		if(blockShowOption < 2){
			sendPeerMsg('move', msg);
		}
		
		param = 'obj=' + msg.step + '_' + msg.id + '_' + msg.action + '_' + msg.x + '_' + msg.y + '_' + msg.angle + '_' + msg.thinkTime + '_' + msg.moveTime;
		requestServer(apiCode, "Move", param);
		
		//forced to align blcoks to grid so as to eliminate accumulated errors (previously x/y/a are not aligned)
		this.father.translateX = gridSize*msg.x;
		this.father.translateY = gridSize*msg.y;
		this.father.rotateAngle = RadPerGrid*msg.angle/DegPerGrid;
		
		if(isSimulation){
			onFinish('Move', moveMsg);
		}

		return false;
	};

	z.onClientMouseMove = function(e){
		
		if(gameover){
			return; //game has been over
		}
		
		if(!e){
			e = window.event; //IE
		}
		e.preventDefault();

		if(e.type == "touchmove"){
			e = e.touches[0];
		}
		
		var clientX = (e.clientX),
			clientY = (e.clientY);

		var pos = this.father.board.boardDiv.getBoundingClientRect();
		var gridSize = this.father.board.gridSize;

		if(blockBeingTranslated != null){
			me = blockBeingTranslated;
			var newX = prevX + clientX - mouseStartX;
			var newY = prevY + clientY - mouseStartY;
			
			var xx = newX/gridSize;
			var yy = newY/gridSize;			
			if(currentMsg.move2grid == 1){
				xx = Math.round(newX/gridSize);
				yy = Math.round(newY/gridSize);
			}

			if(xx+this.father.width/2 < 0 || xx+this.father.width/2 > currentMsg.gridsize ||
				yy+this.father.height/2 < 0 || yy+this.father.height/2 > currentMsg.gridsize){
				return false;
			}

			me.father.translateX = newX;
			me.father.translateY = newY;
		}else if(blockBeingRotated != null){												//rotate action
			me = blockBeingRotated;
			var mouseXFromCentre = e.clientX - pos.left - me.father.translateX - gridSize*this.father.width/2;
			var mouseYFromCentre = e.clientY - pos.top - me.father.translateY - gridSize*this.father.height/2;
//			var mouseXFromCentre = e.clientX - pos.left - (me.father.translateX - gridSize*this.father.width/2)*this.father.board.gScale;
//			var mouseYFromCentre = e.clientY - pos.top - (me.father.translateY - gridSize*this.father.height/2)*this.father.board.gScale;
			var mouseAngle = Math.atan2( mouseYFromCentre, mouseXFromCentre );
			me.father.rotateAngle += mouseAngle - mouseStartAngle;
			mouseStartAngle = mouseAngle;
		}else{
			me = this;
			return false;
		}
						
		transformBlock(me.father.div, me.father.translateX, me.father.translateY, me.father.rotateAngle);

		return false;
	};

	z.getAng = function(a, b){
		if(Math.abs(a)>Math.abs(b)){
			var ang =  Math.atan(b/a);
			if(a<0) ang += Math.PI;
		}else{
			var ang = Math.PI/2 - Math.atan(a/b);
			if(b<0) ang += Math.PI;
		}
		return ang;
	}

	return z;
}

/*function fixTo(a, b){
	var f = Math.round;
	if(b===0)     return f(a);
	else if(b==1) return f(a*10)/10;
	else if(b==3) return f(a*1000)/1000;
	else		  return f(a*100)/100
}
*/
function transformBlock(ele, x, y, a){
	//align displayed blocks to grid. Please note x/y/a of the block object itself are not aligned
	var gridSize = ele.father.board.gridSize;
	var s = ele.father.board.gScale;

	var xx = x;
	var yy = y;
	if(currentMsg.move2grid == 1){
		xx = gridSize*Math.round(x/gridSize);
		yy = gridSize*Math.round(y/gridSize);
	}
	
	var str = ele.style.transformOrigin.split("px");
	xx = xx*s + parseInt(str[0])*(s-1);
	yy = yy*s + parseInt(str[1])*(s-1);
	
	var alpha = DegPerGrid*a/RadPerGrid;
	if(currentMsg.rotate2grid == 1){
		alpha = DegPerGrid*Math.round(a/RadPerGrid);
	}

	ele.style.webkitTransform = 'translate(' + xx + 'px,' + yy + 'px) rotate(' + alpha + 'deg) scale(' + s + ')';
	ele.style.MozTransform = 'translate(' + xx + 'px,' + yy + 'px) rotate(' + alpha + 'deg) scale(' + s + ')';
	ele.style.msTransform = 'translate(' + xx + 'px,' + yy + 'px) rotate(' + alpha + 'deg) scale(' + s + ')';
	ele.style.OTransform = 'translate(' + xx + 'px,' + yy + 'px) rotate(' + alpha + 'deg) scale(' + s + ')';
	ele.style.transform = 'translate(' + xx + 'px,' + yy + 'px) rotate(' + alpha + 'deg) scale(' + s + ')';
}
  
function onCountdown(msg){
	initMsg = msg;
	
	if(msg.targetshapes != undefined){
		role = 'teller';
	} else {
		role = 'listener';
	}

	if(msg.countdown > 0){
		countdown = Math.floor(msg.countdown/1000);
	} else {
		countdown = 0;
	}
	
	//start voice at end of countdown time, or start immediately if it is zero or negative
	if(role == 'teller'){
		if(countdown > 0){
			timer4 = setTimeout(startVoice, countdown*1000);
		} else {
			startVoice();			
		}
	} else if(role == 'listener') {
		timer4 = setTimeout(onInit, (countdown+2)*1000);
	}
	
	//display countdown with additional 2 seconds (2 seconds after starting voice)
	countdown = countdown + 2;
	document.getElementById("countdown").innerHTML = countdown;	
	timer1 = setInterval('countdown--;document.getElementById("countdown").innerHTML = countdown;', 1000);		
		
	requestServer("GameLog", "Add", "logtype=Init&details=countdown_start");
}

function startVoice(){
	//init page 2 seconds after starting voice 
	JavaScriptInterface.nativeCommand('startVoice', '');
	timer4 = setTimeout(onInit, 2000);
	if(isSimulation){
		console.log("startvoice");
	}
	requestServer("GameLog", "Add", "logtype=Init&details=startvoice");
}

function onInit(){
	
	var myL, myT, myW, myH;
	var msg = initMsg;
//	var targetbackground_i;
	var targetviewport;
	
	if(msg.level != undefined){
		switch(msg.level){
		case 0: backgroundOption = 1;	//1 - fixed
				blockShowOption = 0;	//0 - display all time
				blockMoveOption = 0;	//0 - forced in place
				break;
		case 1: backgroundOption = 2;	//2 - selectable
				blockShowOption = 1;	//1 - display after background is set
				blockMoveOption = 0;	//0 - forced in place
				break;
		case 2: backgroundOption = 2;	//2 - selectable
				blockShowOption = 2;	//2 - display only when block is in place
				blockMoveOption = 0;	//0 - forced in place
				break;
		case 3: backgroundOption = 2;	//3 - selectable
				blockShowOption = 3;	//2 - display only when all blocks are in place
				blockMoveOption = 0;	//0 - forced in place
				break;
		case 4: backgroundOption = 3;	//3 - selectable and hidden at the teller side
				blockShowOption = 3;	//2 - display only when all blocks are in place
				blockMoveOption = 1;	//0 - no forced in place
		}
	}
	
//	requestServer("GameLog", "Add", "logtype=Init&details=init_start");

	document.getElementById('titlebar').style.visibility = "visible";
	document.getElementById('titlebar').style.width = "100%";
	document.getElementById('board-page').style.visibility = "visible";
	document.getElementById('countdown-page').style.visibility = "hidden";
	clearInterval(timer1);

	document.getElementById("board-page").style.display = "block";
	document.getElementById("board-page").addEventListener("mousedown", onClearFocus, false);
	document.getElementById("board-page").addEventListener("touchstart", onClearFocus, false);
	
	startCountdownClock(msg.timelimit);
	
//	titleHeight =  document.getElementById("points").scrollHeight;
	titleHeight = 0;
	
	currentMsg = msg;	
	points = msg.maxscore;

	DegPerGrid = 360/currentMsg.anglesize;
	RadPerGrid = 2*Math.PI/currentMsg.anglesize;
	
	myL = 0;
	myW = screenWidth;
	myH = screenWidth;
	myT = screenHeight - titleHeight - screenWidth;
	if(myT < screenWidth/4){
		myT = screenWidth/4;
		myW = screenHeight - titleHeight - myT;
		myH = myW;
	}else if(myT > screenWidth/2){
		myT = screenWidth/2;
	}
	
	document.getElementById("hints").style.top = titleHeight + 'px';
	
	if(backgroundOption < 2){
		//use first background in the array for "fixed background" and no use for "no background"
		targetbackground_i = 0;
	} else {
		//find target background index in the array, if background is selectable
		for(var i=0; i<msg.backgrounds.length; i++){
			if(msg.backgrounds[i].bgidx == msg.targetbackgroundidx){
				targetbackground_i = i;
				break;
			}
		}
	}

	var gameDate = new Date();
	currentTime = gameDate.getTime();
	
//	timer4 = setTimeout("JavaScriptInterface.nativeCommand('micOn', '')", 1000);
	
	if(role == 'teller'){
//		JavaScriptInterface.nativeCommand('startVoice', '');
	
		workBoard = new Board('viewOnly');
		workBoard.setBounds('workArea', myL, myT+titleHeight, myW, myH, currentMsg.gridsize);
		
		//target viewport is reserved for future use. The background currently does not support target viewport
		targetviewport = msg.targetviewport;
		if(targetviewport == undefined){
			targetviewport = new Object();
			targetviewport.posx = 0;
			targetviewport.posy = 0;
			targetviewport.size = currentMsg.gridsize;
		}

		myL = 5;
		myW = myT - 10;
		myH = myT - 10;
		myT = 5;
		targetBoard = new Board('viewOnly');
		targetBoard.setBounds('targetArea', myL, myT+titleHeight, myW, myH, targetviewport.size);		
		correctBackgroundFile = msg.backgrounds[targetbackground_i].shapename;
//		currentBackgroundFile = correctBackgroundFile;
		if(backgroundOption > 0){		
			targetBoard.setBackground(correctBackgroundFile);
		}
		
		if(backgroundOption > 1){
			document.getElementById("hints").innerHTML = "向对方描述屏幕上方图样";
		}
		
		if(blockShowOption == 3){
			document.getElementById("prompt").innerHTML = "此难度看不到TA的操作";
		}
		
		document.getElementById("hints").style.left = myW + 10 + 'px';
		document.getElementById("hints").style.width = screenWidth - myW - 10 + 'px';
		
		if(isSimulation){
			//simulate movement from another plater
			if(backgroundOption == 2){
				timer2 = setTimeout("onChgBkg({'type': 'chgBkg', 'id':5, 'picname':'sample5.jpg'});timer2 = setInterval(simulateMoves,2000);", 3000);
			} else {
				timer2 = setInterval(simulateMoves,2000);
			}
		}
	}
	else if (role == 'listener'){
//		timer4 = setTimeout("JavaScriptInterface.nativeCommand('micOn', '')", 2500);
		JavaScriptInterface.nativeCommand('micOn', '');
		
		document.getElementById("targetArea").style.visibility = "hidden";
		document.getElementById("prompt").style.visibility = "hidden";
		if(backgroundOption > 1){
			document.getElementById('bkgButton').style.visibility = "visible";
			initButton('bkgButton', 'white');
			
			for(var i=0; i<msg.backgrounds.length; i++){
				
				var imgNode = document.createElement("img");
				imgNode.id = msg.backgrounds[i].bgidx;
				imgNode.src = msg.backgrounds[i].shapename;
				imgNode.shapepath = msg.backgrounds[i].shapename;
				imgNode.className = 'imageItem';
				imgNode.onclick = onSelectPic;

				document.getElementById("image-list").appendChild(imgNode);
				imgNode.addEventListener("touchstart", onTouchPic, true);
				imgNode.addEventListener("touchmove", onTouchMove, true);
			}	
		}
	
		workBoard = new Board('movable');
		workBoard.setBounds('workArea', myL, myT+titleHeight, myW, myH, currentMsg.gridsize);
		document.getElementById("image-panel").style.top = myT + titleHeight + 'px';
		
//		targetBoard = workBoard;
		
		if(blockShowOption == 2){
			document.getElementById("hints").innerHTML = "根据对方指令，移动下方物品。移对了对方才能看到该物品";
		} else if(blockShowOption == 3){
			document.getElementById("hints").innerHTML = "根据对方指令，移动下方物品。所有物品移对了对方才能看到";
		} else {
			document.getElementById("hints").innerHTML = "根据对方指令，移动下方物品";
		}

		if(backgroundOption > 1){
			document.getElementById("bkgButton").style.top = myT + titleHeight - document.getElementById("bkgButton").clientHeight - 30 + 'px';
			onChangeBackground();
		}
	}
	
	//create blocks and set block position and visibility
	for (x in msg.shapes){
		var s = msg.shapes[x];
		var b1 = workBoard.createBlock(s.shapename, s.shapeid, s.width, s.length, true);
		var b2 = workBoard.createBlock(s.shapename, s.shapeid+100, s.width, s.length, false);
		
		//setup init blocks
		if(msg.initshapes == undefined){
			//happens when blockShowOption is 2 and 3
			var sp = msg.targetshapes[x];
		} else {
			var sp = msg.initshapes[x];
		}
		b1.setLocation(sp.posx, sp.posy);
		b1.setAngle(sp.angle);
		b1.display();
		if(role == 'listener' || blockShowOption == 0){
			b1.display();
		} else {
			b1.hide();
		}

		//setup blocks in final position for comparison when ended with "zero" 
		b2.setLocation(sp.posx, sp.posy);
		b2.setAngle(sp.angle);
		b2.hide();
		
		//create and setup target blocks
		if(role == 'teller'){
			var b = targetBoard.createBlock(s.shapename, s.shapeid, s.width, s.length, false);
			var sp = msg.targetshapes[x];
			b.setLocation(sp.posx, sp.posy);
			b.setAngle(sp.angle);
			b.display();
		}
	}
	
	//backgroundOption 0 has no background, 2 and 3 are selected by the listener
	if(backgroundOption == 1){
		workBoard.setBackground(msg.backgrounds[targetbackground_i].shapename);
	}
	
	textPoints = document.getElementById('points');
	timer1 = setInterval(displayPoints, 100);
		
	startHeartbeat();
	
	requestServer("GameLog", "Add", "logtype=Init&details=init_complete");
	
}  

function onClearFocus(){
	if(role != 'listener'){
		return;
	}
	
	if(focusBlock != null){
		focusBlock.lastChild.style.visibility = "hidden";
//		focusBlock.firstChild.nextSibling.style.visibility = "hidden";
		focusBlock.style.filter = 'brightness(100%)';
		focusBlock = null;
	}
}

function onSwitchSize(){
	
	if(gameover){
		return;
	}
	var rectWork = targetBoard.getBounds();
	var rectTarget = workBoard.getBounds();
	
	isLargeTargetBoard = !isLargeTargetBoard;
	
	if(isLargeTargetBoard){
		rectTarget.top = 0;
		rectWork.top = rectTarget.height + 5;
		document.getElementById("hints").style.top = rectTarget.height + "px";
	} else {
		rectTarget.top = 5;
		rectWork.top = rectTarget.height + 10;
		document.getElementById("hints").style.top = "0px";
	}
	targetBoard.resizeBounds(rectTarget);
	workBoard.resizeBounds(rectWork);
}

function onMove(movestep){
	//Note: this function is to process messages from the peer, not from the server

	if(movestep.isright){
		sendPeerMsg('inplaceAck');
	}
	
	var a = workBoard.findBlock(movestep.id);
	if(a != null){
		if(blockShowOption == 2){
			if(movestep.isright){
				a.display();
			}
		}
		
		a.setLocation(movestep.x, movestep.y);
		a.setAngle(movestep.angle);
		a.div.style.zIndex = maxzindex++;
		
		if(movestep.action != 0){
			points = points - currentMsg.stepscore;
		}
	}
}

function onChgBkg(msg){
//	document.getElementById("workArea").style.backgroundImage = 'url('+msg.picname+')';

	if(backgroundOption == 2){
		workBoard.setBackground(msg.picname);
	}
	currentBackgroundFile = msg.picname;
	currentBG = msg.id;
	
	if(blockShowOption == 1){
		for (x in currentMsg.initshapes){
			var a = workBoard.findBlock(currentMsg.initshapes[x].shapeid);
			a.display();
		}
	}
	
	if(blockShowOption == 2){
		document.getElementById("hints").innerHTML = "指挥对方移动物品，对方移对了你就能看到该物品";
	} else if(blockShowOption == 3){
		document.getElementById("hints").innerHTML = "指挥对方移动物品，对方全部物品移对了你才能看到";
	} else {
		document.getElementById("hints").innerHTML = "指挥对方移动物品，拼成屏幕上方图样";
	}
	points -= currentMsg.bgscore;
}

function onGameTimeout(){
	if(role == 'listener'){
		requestServer(apiCode, "Zero");
	}
	document.getElementById("countdownClock").innerHTML = "剩余时间：0 秒";
	
	clearInterval(timer1);
	if(isSimulation){
		onFinish('Zero', lastMsg);
	}
}

function onTouchPic(e){
	if(!e.target.selected){
		a = e.target;
		setTimeout("a=null;", 400);
	}
}

function onTouchMove(e){
	a = null;
}

function onChangeBackground(){
	document.getElementById('background-page').style.visibility = "visible";
	document.getElementById('board-page').style.display = "none";
	
	var gameDate = new Date();
	var t = gameDate.getTime();
	thinkTime = t - currentTime;
	currentTime = t;
}

function onSelectPic(image){
	if(a!=null){
		document.getElementById('board-page').style.display = "block";
		document.getElementById('background-page').style.visibility = "hidden";
	
		if(image != null){
//			document.getElementById("workArea").style.backgroundImage = 'url('+image.target.src+')';
			workBoard.setBackground(image.target.src);
			
			step++;
			var gameDate = new Date();
			var t = gameDate.getTime();
			var operateTime = t - currentTime;
			currentTime = t;
			param = 'obj=' + step + '_' + image.target.id + '_' + thinkTime + '_' + operateTime;
			requestServer(apiCode, "ChgBG", param);
			
			currentBG = image.target.id;
			currentBackgroundFile = image.target.src;
			currentAction = 0;
			
			sendPeerMsg('chgBkg', {"id": image.target.id, "picname": image.target.shapepath});
			
			points -= currentMsg.bgscore;
			document.getElementById("bubble").innerHTML = '-' + currentMsg.bgscore;
			document.getElementById("bubble").style.visibility = "visible";
			timer4 = setTimeout("document.getElementById('bubble').style.visibility = 'hidden'", 1000);
			
			if(isSimulation){
				setTimeout("onFinish('ChgBG', {'next':0, 'isright':true, 'score':12345})", 500);
			}
		}
	}
}

function resendInplaceMove(){
	sendPeerMsg('move', lastMoveMsg);
	if(resendCount < 2){
		timer2 = setTimeout(resendInplaceMove, 2500);
		resendCount++;
	}
}

function onFinish(request, msg){
	//on response from the server for Move, Zero and ChgBg request, only use to check finishing of the game
	var duration = 3000;
	
	if(gameover){
		return; //game has been over
	}

	points = msg.score;
	textPoints.innerHTML = '得分 ' + points;

	if(request == 'Move'){
		if(currentMsg.stepscore > 0 && currentAction != 0 && msg.score > 0){
			document.getElementById("bubble").innerHTML = '-' + currentMsg.stepscore;
			document.getElementById("bubble").style.visibility = "visible";
			timer4 = setTimeout("document.getElementById('bubble').style.visibility = 'hidden'", 1000);
		}
		if(msg.isright == true && blockMoveOption == 0){
			var a = workBoard.findBlock(msg.shapeIdx);
			if(a != null){
//				requestServer("GameLog", "Add", "logtype=in-place&details=x:"+msg.posx+"y:"+msg.posy);
				a.div.removeEventListener("touchstart", a.div.onMyMouseDown, false);
				a.div.removeEventListener("touchend", a.div.onMyMouseUp, false);
				a.div.removeEventListener("mousedown", a.div.onMyMouseDown, false);
				a.div.removeEventListener("mouseup", a.div.onMyMouseUp, false);
				a.setLocation(msg.posx, msg.posy);
				a.setAngle(msg.angle);
				a.div.style.zIndex = deadzindex;
				document.getElementById("snd_inplace").play();
			}
			
			if(blockShowOption < 3){
				msg.x = msg.posx;
				msg.y = msg.posy;
				msg.id = msg.shapeIdx;
				sendPeerMsg('move', msg);
				
				lastMoveMsg = msg;
				timer2 = setTimeout(resendInplaceMove, 2500);
				resendCount = 0;
			}
			
			requestServer("GameLog", "Add", "logtype=Move&details=move in place:" + msg.id);
		}
	} else if(request == 'ChgBG' && msg.isright == true){
		disableButton(document.getElementById("bkgButton"));
//		correctBackgroundFile = currentBackgroundFile;
	}

	if(msg.next == 0){
		if(role == 'listener'){
			sendPeerMsg('syncpoint', {"points": points});
		}
		return;
	}
	
// following code is executed only once when game is over
	
	if(role == 'teller'){
		requestServer("GameLog", "Add", "logtype=Debug&details=finish_teller1");
	}
	
	if(role == 'teller'){
		if(isLargeTargetBoard){
			onSwitchSize();
		}
	}

	gameover = true;
	clearInterval(timer1);
	clearInterval(timerCountdownClock);
	
	if(msg.score > 0){
		document.getElementById("snd_success").play();
	}
//	JavaScriptInterface.nativeCommand('micOff', '');
	JavaScriptInterface.nativeCommand('endVoice', '');
	nextGame = msg.next;
		
	if(role == 'listener'){
		//display all blocks at final position at the teller side when finished (for level 3,4,5)
		msg.finalpos = new Array();
		for (x in currentMsg.shapes){
			var b = currentMsg.shapes[x];
			var a = workBoard.findBlock(b.shapeid);
			var p = a.getLocation();
			p.angle = a.getAngle();
			p.id = b.shapeid;
			msg.finalpos.push(p);
		}
		sendPeerMsg('finish', msg);
	} else if(msg.finalpos != undefined){
		var pos = msg.finalpos;
		for(var i=0; i<pos.length; i++){
			var a = workBoard.findBlock(pos[i].id);
			if(a != null){
				a.setLocation(pos[i].x, pos[i].y);
				a.setAngle(pos[i].angle);
				a.display();
			}
		}
		requestServer("GameLog", "Add", "logtype=Debug&details=finish_teller2");
	
		if(backgroundOption > 1){
			workBoard.setBackground(currentBackgroundFile);
		}
	}
/*	else {
		for(var i=0; i<initMsg.initshapes.length; i++){
			var a = workBoard.findBlock(initMsg.initshapes[i].shapeid);
			if(a != null){
				a.display();
			}
		}
		workBoard.setBackground(currentBackgroundFile);
	}
*/
	document.getElementById("score").innerHTML = msg.score;
	
	finishMsg = msg;
	
	//only does it when returns from "zero" (both teller and listener)
	if(backgroundOption > 1 && msg.targetbackgroundidx != undefined && msg.targetbackgroundidx != currentBG){
		document.getElementById("prompt").innerHTML = "背景选错了！";
		document.getElementById('prompt').style.visibility = "visible";
		
		for (x in currentMsg.backgrounds){
			if(currentMsg.backgrounds[x].bgidx == msg.targetbackgroundidx){
				correctBackgroundFile = currentMsg.backgrounds[x].shapename;
			}
		}
		
		rightResult = true;
		timerRightPos = setInterval(showRightBackgroud, 1500);
		
		duration = 10000;
	} else if(msg.targetshapes != undefined){
		for (x in msg.targetshapes){
			var s = msg.targetshapes[x];
			var a = workBoard.findBlock(s.shapeid+100);
			a.setLocation(s.posx, s.posy);
			a.setAngle(s.angle);
			a.moveToTop();
		}
		for (x in currentMsg.shapes){
			var b = currentMsg.shapes[x];
			var a = workBoard.findBlock(b.shapeid);
			a.setFilter("grayscale(70%) brightness(130%)");
		}
		
//		workBoard.setFilter("grayscale(100%) brightness(120%)");
		document.getElementById("mask").style.visibility = "visible";
		document.getElementById("prompt").innerHTML = "没移对！闪烁位置才对！";
	
		document.getElementById('prompt').style.visibility = "visible";
		rightResult = true;
		timerRightPos = setInterval(showRightPosition, 500);
		
		duration = 10000;
	}

	if(msg.next > 0 && msg.record != undefined){
		if(msg.score > msg.record.score && msg.score>=5000){
			JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"恭喜，您破本题记录了！\",\"t\":\"3\"}');
			if(isSimulation){
				alert('您破本题记录了！');
			}
		}
		duration += 3000;
	}
	
	timer3 = setTimeout(showResult, duration);
}

function showRightBackgroud(){
	if(rightResult){
		workBoard.setBackground(correctBackgroundFile);
		document.getElementById("prompt").innerHTML = "这才是正确背景";
	} else {
		workBoard.setBackground(currentBackgroundFile);
		document.getElementById("prompt").innerHTML = "背景选错了！";
	}
	rightResult = !rightResult;
}

function showRightPosition(){
	for (x in finishMsg.targetshapes){
		var b = finishMsg.targetshapes[x];
		var c = workBoard.findBlock(b.shapeid+100);
		if(rightResult){
			c.display();
		} else {
			c.hide();
		}
	}
	rightResult = !rightResult;
}

function showResult(){
	clearInterval(timerRightPos);
	document.getElementById("board-page").style.display = "none";
	document.getElementById('titlebar').style.visibility = "hidden";
	document.getElementById("result-page").style.visibility = "visible";
	timer3 = setTimeout(onNextStep, 5000);
}

function onNextStep(){

	document.getElementById("board-page").style.display = "none";
	document.getElementById("result-page").style.visibility = "visible";
	
	switch(nextGame){
	case 3:
	case '3':
	case '3.0':
		clearInterval(timer5);		
		showFinalResult();
		break;
	case 2:
	case '2':
	case '2.0':
		JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"正在互换角色...\",\"t\":\"3\"}');
	case 1:
	case '1':
	case '1.0':
		document.location.reload();
		break;
	}
}

function showGameResult(){	

	document.getElementById("subscore").innerHTML = (finishMsg.totalscore - finishMsg.score) + ' + ' + finishMsg.score;
	
	var score1 = "（无记录）";
	var score2 = "（无记录）";
	var users1 = "";
	var users2 = "";
	
	if(finishMsg.records[0] != undefined){
		if(finishMsg.records[0].score >= 5000 && finishMsg.records[0].users != undefined){
			score1 = finishMsg.records[0].score;
			users1 = finishMsg.records[0].users[0] + ' & ' + finishMsg.records[0].users[1];
		}
	}
	if(finishMsg.records[1] != undefined){
		if(finishMsg.records[1].score >= 5000 && finishMsg.records[1].users != undefined){
			score2 = finishMsg.records[1].score;
			users2 = finishMsg.records[1].users[0] + ' & ' + finishMsg.records[1].users[1];
		}
	}
	
	document.getElementById("recordA_score").innerHTML = '第1题：' + score1;
	document.getElementById("recordA_names").innerHTML = users1;
	document.getElementById("recordB_score").innerHTML = '第2题：' + score2;
	document.getElementById("recordB_names").innerHTML = users2;

	document.getElementById("exitButton").style.bottom = '10rem';
	document.getElementById("commentButton").style.bottom = '10rem';
}

function displayPoints(){
	points = points - currentMsg.timescore/10;
	if(points <= 0){
		clearInterval(timer1);
		points = 0;
		
		if(role == 'listener'){
			requestServer(apiCode, "Zero");
		}
		
		//test simulation
		if(isSimulation){
			onFinish('Move', lastMsg);
		}
	}
	
	textPoints.innerHTML = '得分 ' + points;
}

//only for test simulation
function simulateMoves(){
	if(step < simSteps.length){
		var movestep = eval("(" + simSteps[step++] + ")");
		onMove(movestep);
		onNativeMsg('peer', '{"type":"syncpoint","points":'+ points +',"matchid":' + matchidx +'}');
	}
	
	if(step == simSteps.length){
		clearTimeout(timer1);
		clearTimeout(timer2);
		
		onFinish('Move', lastMsg);
	}
}

//initialization before receiving the GetInitInfo message
function initGame(){
	if(isSimulation){
		lastMsg = eval("(" + lastString + ")");
		moveMsg = eval("(" + moveString + ")");
	}
	currentAction = 0;
}

function onGameNativeMsg(source, msg){
	
//	var msg = eval("(" + jMsg + ")");
	
	switch(source){
	case 'server':		
		switch(msg.request){
		case 'GetInitInfo':
			onCountdown(msg.info);
			break;
		case 'Move':
		case 'Zero':
		case 'ChgBG':
			onFinish(msg.request, msg.info);
			break;
		}
		break;
		
	case 'peer':
		switch(msg.type)
		{
		case 'move':
			onMove(msg);
			break;
		case 'chgBkg':
			onChgBkg(msg);
			break;
		case 'finish':
			onFinish('', msg);
			break;
		case 'inplaceAck':
			clearTimeout(timer2);
			break;
		case 'syncpoint':
			points = msg.points;
			break;
		}
		break;
		
	case 'system':
		switch(msg.code)
		{
		case 200:
		case '200':
		case '200.0':
		case 208:
		case '208':
		case '208.0':
			timer4 = setTimeout("JavaScriptInterface.nativeCommand('micOn', '')", 2000);
			if(isSimulation){
				console.log("micOn");
			}
			break;
		}
	}
}

