//action definition for tutorial at listener side

var initString = '{"countdown":5497,"matchidx":23958,"gridsize":30,"anglesize":24,"maxscore":10000,"stepscore":0,"timescore":20,"bgscore":0,"move2grid":0,"rotate2grid":1,"level":0,"levelname":"普通","timelimit":420,"backgroundoption":1,"blockmoveoption":0,"blockshowoption":0,"targetbackgroundidx":104,"backgrounds":[{"bgidx":104,"shapename":"../imgbj/tangrambg99.jpg"}],"shapes":[{"shapeid":242,"length":3,"width":8,"shapename":"../imgshape/tangramobj3.png"},{"shapeid":243,"length":5,"width":3,"shapename":"../imgshape/tangramobj4.png"}],"targetshapes2":[{"shapeid":242,"angle":90.0,"posx":2.344,"posy":13.167,"repeat":180,"next":243},{"shapeid":243,"angle":225.0,"posx":4.219,"posy":7.854,"prev":242, "steps":2}],"initshapes":[{"shapeid":242,"angle":90.0,"posx":22.677,"posy":4.313},{"shapeid":243,"angle":0.0,"posx":17.515,"posy":2.646}]}';

var timeoutString = '{"finished": false, "next": 2.0, "targetshapes": [{"shapeid":242,"angle":90.0,"posx":2.344,"posy":13.167},{"shapeid":243,"angle":225.0,"posx":4.219,"posy":7.854}]}';

var boxScore = '{"left":"", "right":"2px", "top":"2px", "bottom":"", "width":"4.5em", "height":"1.8em"}';
var boxBubble = '{"left":"", "right":"0.3em", "top":"1em", "bottom":"", "width":"5em", "height":"3em"}';
var boxButton = '{"left":"", "right":"0.3em", "top":"7em", "bottom":"", "width":"7em", "height":"3em"}';
var boxObjs = '{"left":"", "right":"2px", "top":"53vw", "bottom":"", "width":"48vw", "height":"40vw"}';

var actions = [
    '{"type": "GetInitInfo", "msg":' + initString + ', "delay":-1}',					//init
    '{"type": "narrate", "sound":"sound/s11_1.mp3", "box":' + boxScore + '}',
    '{"type": "talk", "sound":"sound/u13.mp3", "delay":-1}',
    '{"type": "Move", "msg": {"finished": false, "isright":false, "next":0}}',			//move, not in place defaultly
    '{"type": "talk", "sound":"sound/u14_1.mp3", "check":"withNext"}',
    '{"type": "narrate", "sound":"sound/s12_1.mp3", "check":"firstRotate"}',
    '{"type": "talk", "sound":"sound/u14_2.mp3", "check":"withNextStep"}',
    '{"type": "talk", "sound":"sound/u15.mp3", "check":"withPrev"}',
    '{"type": "talk", "sound":"sound/u16.mp3,sound/u17.mp3", "check":"angle"}',
    '{"type": "talk", "sound":"sound/u18.mp3,sound/u19.mp3", "check":"position"}',
    '{"type": "talk", "check":"close", "delay":-1}',
    '{"type": "Move", "msg": {"finished": false, "isright":true, "next":0}}',			//final move
    '{"type": "narrate", "sound":"sound/s15.mp3"}',
    '{"type": "narrate", "sound":"sound/s16_1.mp3"}',
    '{"type": "Zero", "msg": {"finished": true, "next":2}, "delay":-1}',				//virtual move, completed
    '{"type": "Zero", "msg":' + timeoutString + ',"delay":-1}'							//timeout, exit
];

var wrongBkgAction = 0;
var correctBkgAction = 0;
var moveAction = 3;
var finishAction = 11;
var timeoutAction = 15;

var startMode = 2;		//0 - direct start, 1 - countdown; 2 - click to start (the only way for voice to work)
var introText = '引导程序将帮助你迅速熟悉“沟通成本”测评活动的规则。完成后还能获得1星。';
var nextPage = 'index.html?tutorTellerPS2S';

var gameType = GetQueryString("gametype");
if (gameType == 0) {
    introText = '引导程序将帮助你迅速熟悉“沟通成本”活动的规则。';
    nextPage = 'index.html?tutorTellerPS2S&gametype=' + gameType;
}