//action definition for tutorial at teller side

var initString = '{"countdown":5222,"matchidx":23957,"gridsize":30,"anglesize":24,"maxscore":10000,"stepscore":0,"timescore":20,"bgscore":0,"move2grid":0,"rotate2grid":1,"level":0,"levelname":"普通","timelimit":420,"backgroundoption":1,"blockmoveoption":0,"blockshowoption":0,"targetbackgroundidx":10,"backgrounds":[{"bgidx":10,"shapename":"../imgbj/bj_gui_ji.jpg"}],"shapes":[{"shapeid":222,"length":2,"width":4,"shapename":"../imgshape/rmouse.png"},{"shapeid":221,"length":4,"width":3,"shapename":"../imgshape/lcat.png"},{"shapeid":239,"length":1,"width":14,"shapename":"../imgshape/cm_rectangle.png"},{"shapeid":230,"length":3,"width":3,"shapename":"../imgshape/cm_circle.png"}],"targetshapes":[{"shapeid":222,"angle":0.0,"posx":8.652,"posy":15.921},{"shapeid":221,"angle":0.0,"posx":21.842,"posy":13.164},{"shapeid":239,"angle":150.0,"posx":8.302,"posy":18.398},{"shapeid":230,"angle":0.0,"posx":9.1,"posy":17.857}],"initshapes":[{"shapeid":222,"angle":0.0,"posx":15.576,"posy":24.646},{"shapeid":221,"angle":0.0,"posx":25.941,"posy":23.994},{"shapeid":239,"angle":0.0,"posx":0.857,"posy":25.668},{"shapeid":230,"angle":0.0,"posx":21.054,"posy":24.625}]}';

var boxTargets = '{"left":"2px", "right":"", "top":"1.9em", "bottom":"", "width":"48vw", "height":"48vw"}';
var boxNetWarning = '{"left":"2px", "right":"", "top":"2px", "bottom":"", "width":"13.5em", "height":"1.8em"}';
var boxObjs = '{"left":"2px", "right":"", "top":"135vw", "bottom":"", "width":"98vw", "height":"18vw"}';

var actions = [
'{"type": "GetInitInfo", "msg":' + initString + ', "delay":-1}',
'{"type": "narrate", "sound":"sound/s21_1.mp3", "delay":1000}',					//system voice: introduction
'{"type": "talk", "sound":"sound/m3.mp3"}',										//user 1 voice: describe table
'{"type": "move", "msg": {"id": 221, "x": 21.842, "y": 13.164, "angle": 0, "score":700}, "delay":2000}',	//move cat
'{"type": "move", "msg": {"id": 239, "x": 10.302, "y": 12.398, "angle": 0.0, "score":600}, "delay":1000}',	//move bar to center
'{"type": "move", "msg": {"id": 239, "x": 10.302, "y": 12.398, "angle": 150.0, "score":600}, "delay":1000}',//rotae bar
'{"type": "move", "msg": {"id": 239, "x": 8.302, "y": 18.398, "angle": 150.0, "score":600}, "delay":2000}',	//move bar
'{"type": "move", "msg": {"id": 230, "x": 9.1, "y": 17.857, "angle": 0.0, "score":600}, "delay":2000}',		//move circle
'{"type": "move", "msg": {"id": 222, "x":3.652, "y":16.421, "angle":0.0, "score":800}, "delay":1000}',		//move mouse to wrong position
'{"type": "startNetWarning"}',
'{"type": "narrate", "sound":"sound/s31.mp3", "box":' + boxNetWarning + '}',
'{"type": "endNetWarning"}',
'{"type": "narrate", "sound":"sound/s32.mp3", "box":' + boxNetWarning + '}',
'{"type": "talk", "sound":"sound/u22.mp3"}',									//user 2 voice: ask mouse
'{"type": "talk", "sound":"sound/m4.mp3"}',										//user 1 voice: describe mouse
'{"type": "move", "msg": {"id": 222, "x":8.652, "y":15.921, "angle":0.0, "score":800}}',			//move mouse to right position
'{"type": "narrate", "sound":"sound/s26.mp3"}',									//system voice: congrat
'{"type": "narrate", "sound":"sound/s27.mp3"}',									//system voice: guide for the next
'{"type": "Zero", "msg": {"finished": true, "next":3}, "delay":-1}',			//game completed
];

var startMode = 2;		//0 - direct start, 1 - countdown; 2 - click to start (the only way for voice to work)
var introText = '交换角色后，你将看到描述方的用户界面。请仔细观看操作演示。';
var nextPage = 'tutorialResult.html?gamecode=PS2S&gametype=' + GetQueryString("gametype");