﻿var token = "";
var isSimulation = false;
var sim = {};

var debug=false;

var sUserAgent = navigator.userAgent.toLowerCase();
var isIOS = (sUserAgent.match("ipad") == "ipad") || (sUserAgent.match("iphone") == "iphone");
if (isIOS) {
    JavaScriptInterface = new Object();
    JavaScriptInterface.nativeCommand = function (cmd, param) {
        window.webkit.messageHandlers.nativeCommand.postMessage({ "cmd": cmd, "param": param });
    }
    JavaScriptInterface.nativeSendMsg = function (dest, msg) {
        window.webkit.messageHandlers.nativeSendMsg.postMessage({ "dest": dest, "msg": msg });
        //			window.webkit.messageHandlers.nativeSendMsg.postMessage('{"dest":"'+dest+'","msg":"'+msg+'"}');
    }
}
if (isSimulation) {
    //simulate the native object
    JavaScriptInterface = new Object();
    JavaScriptInterface.nativeSendMsg = function (dest, msg) {
        //			document.getElementById('debug').innerHTML = 'dest: ' + dest + '<br />msg: ' + msg;
    };
    JavaScriptInterface.nativeCommand = function (cmd, param) {
        //			document.getElementById('debug').innerHTML = 'cmd: ' + cmd + '<br />param: ' + param;
    };
}

function requestServer(request, parameter, postinfo) {
    if (token == null || token == undefined) {
        return;
    }
    var url = "/api/" + request + "?token=" + token;
    if (parameter != null && parameter != undefined) {
        url = url + "&" + parameter;
    }
    if (postinfo == null || postinfo == undefined) {
        postinfo = '';
    }
    JavaScriptInterface.nativeSendMsg(encodeURI(url), postinfo);
}


function GetQueryString(name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
    var r = decodeURI(window.location.search).substr(1).match(reg);
    if (r != null) return unescape(r[2]); return null;
}

function Share(title, link) {
    if (isSimulation) {
        alert('share:' + title + ' ' + link);
    }
    else {
        JavaScriptInterface.nativeCommand('share', '{\"title\":\"' + title + '\", \"link\":\"' + link + '\"}');
    }
}

function MsgBox(title, msg) {
    if (isSimulation) {
        alert(title + '_' + msg);
    }
    else {
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"' + title + '\",\"msg\":\"' + msg + '\",\"t\":\"3\"}');
    }
}

function SetTitle(title) {
    if (isSimulation) {
        document.title = title;
    }
    else {
        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"' + title + '\"}');
    }
}

function onNativeMsg(source, jMsg) {

    var msg = eval("(" + jMsg + ")");

    switch (source) {
        case 'server':
			if(msg.code == 500){
				return;
			}
            //if (msg.code == 603 || msg.code == 604) {
            //    return;
            //} else if (msg.code != 200) {
            //    doExit("服务器无响应");
            //    return;
            //}
            //if (msg.request == 'GetInitInfo' || msg.request == 'GetMatchStatusInfo' || msg.request == 'GameAction') {
            //    if (msg.info.matchidx != undefined) {
            //        matchidx = msg.info.matchidx;
            //    }
            //    break;
            //}
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    //JavaScriptInterface.nativeCommand('exit', '');
                    //window.location.href = "my.html";
                    //MsgBox('提示', '比赛进行中，无法退出！');
                    JavaScriptInterface.nativeCommand('ackback', '');
                    break;
                case 223:
                case '223':
                case '223.0':
                    token = msg.info;
                    if (debug) {
                        document.getElementById('debug').innerHTML += '\ntoken: ' + msg.info;
                    }
                    getInfo();
                    break;
				case 232:
				case '232':
				case '232.0':
					requestServer(apiCode, "GameAction", "act=52");
					break;
				case 233:
				case '233':
				case '233.0':
					requestServer(apiCode, "GameAction", "act=51");
					break;
            }
    }

    if (("undefined" != typeof onGameNativeMsg) && (typeof onGameNativeMsg === "function")) {
        onGameNativeMsg(source, msg);
    }
}
window.onload = function () {
    if (isSimulation) {
        firstdo();
    }
    else {
        JavaScriptInterface.nativeCommand('getToken', '');
    }
};

function firstdo() {
    if (("undefined" != typeof getInfo) && (typeof getInfo === "function")) {
        getInfo();
    }
}

function doExit(msgText){
	JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"'+msgText+'请重新进入\",\"t\":\"3\"}');
	setTimeout("JavaScriptInterface.nativeCommand('exit', '')",3000);
}
