﻿var token = "";
var isSimulation = false;
var sim={};
$(document).ready(function () {
    var sUserAgent = navigator.userAgent.toLowerCase();
    var isIOS = (sUserAgent.match("ipad") == "ipad") || (sUserAgent.match("iphone") == "iphone");
    if (isIOS) {
        JavaScriptInterface = new Object();
        JavaScriptInterface.nativeCommand = function (cmd, param) {
            window.webkit.messageHandlers.nativeCommand.postMessage({ "cmd": cmd, "param": param });
        }
        JavaScriptInterface.nativeSendMsg = function (dest, msg) {
            window.webkit.messageHandlers.nativeSendMsg.postMessage({ "dest": dest, "msg": msg });
            //			window.webkit.messageHandlers.nativeSendMsg.postMessage('{"dest":"'+dest+'","msg":"'+msg+'"}');
        }
    }
    if (isSimulation) {
        //simulate the native object
        JavaScriptInterface = new Object();
        JavaScriptInterface.nativeSendMsg = function (dest, msg) {
            //			document.getElementById('debug').innerHTML = 'dest: ' + dest + '<br />msg: ' + msg;
        };
        JavaScriptInterface.nativeCommand = function (cmd, param) {
            //			document.getElementById('debug').innerHTML = 'cmd: ' + cmd + '<br />param: ' + param;
        };
    }
});

function requestServer(request, parameter, postinfo) {
    var url = "/api/" + request + "?token=" + token;
    if (parameter != null && parameter != undefined) {
        url = url + "&" + parameter;
    }
    if (postinfo == null || postinfo == undefined) {
        postinfo = '';
    }
    JavaScriptInterface.nativeSendMsg(encodeURI(url), postinfo);
}


function GetQueryString(name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
    var r = decodeURI(window.location.search).substr(1).match(reg);
    if (r != null) return unescape(r[2]); return null;
}

function Share(title, link) {
    JavaScriptInterface.nativeCommand('share', '{\"title\":\"' + title + '\", \"link\":\"' + link + '\"}');
}

var _hmt = _hmt || [];
(function () {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?5d95138ed4102fb84213205b85a4bc90";
    var s = document.getElementsByTagName("script")[0];
    s.parentNode.insertBefore(hm, s);
})();