﻿function getInfo() {
    if (isSimulation) {
        var jMsg = sim.certinfo3;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    else {
        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"证书\"}');
        requestServer("League/GetCertInfo");
    }
}

function submitComment() {
    var username = app.username;
    var idnumber = app.idnumber;
    var studentid = app.studentid

    username = username.replace(/\"/g, "").replace(/\'/g, "");
    idnumber = idnumber.replace(/\"/g, "").replace(/\'/g, "");
    studentid = studentid.replace(/\"/g, "").replace(/\'/g, "");
    //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"' + username + '\"}');

    if (username.length == 0 ) {
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"请输入真实姓名！\",\"t\":\"3\"}');
        return false;
    }
    if (idnumber.length == 0 ) {
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"请输入身份证号！\",\"t\":\"3\"}');
        return false;
    }
    var regidnumber = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
    if (!regidnumber.test(idnumber)) {
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"请输入正确的身份证号！\",\"t\":\"3\"}');
        return false;
    }  
    if (studentid.length == 0 ) {
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"请输入学号！\",\"t\":\"3\"}');
        return false;
    }
    if (idx == 0) {
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"Idx错误！\",\"t\":\"3\"}');
        return false;
    }
    var postinfo = '{"idx": "' + idx + '", "username": "' + username + '", "idnumber": "' + idnumber + '","studentid": "' + studentid + '"}';
    requestServer("League/SubmitCertInfo", "", postinfo);
}

function showInfo(msg) {
    app.idx = msg.info.idx;
    app.status = msg.info.status;
    app.imgurl = msg.info.imgurl;
}

// JavaScript source code
function onGameNativeMsg(source, msg) {
    switch (source) {
        case 'server':
            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                if (msg.request == "GetCertInfo")
                    showInfo(msg);
                else if (msg.request == "SubmitCertInfo") {
                    JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"提交成功！\",\"t\":\"3\"}');
                    //showInfo(new { code: 200, info: new { status: 9 } });
                    var m = '{ "code": 200, "info": { "status": 9} }';
                    showInfo(eval("(" + m + ")"));
                }
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand('exit', '');
                    //window.history.back();
                    //window.location.href = "my.html";
                    break;
                default:
                    break;
            }
    }
}