﻿"use strict";

var app = new Vue({
    el: "#app",
    data: {
        init: false,
        style: "",
        curritem: {},
        items: [
            //{
            //    fidx: 122,
            //    nickname: "",
            //    r: 0,
            //    count: 0,
            //}
        ]
    },
    components: {},
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "min-height: " + this.height + "px";
    },
    computed: {},
    methods: {
        tap: function tap() {
            console.log("tap");
        },
        tapItem: function tapItem(item) {
            if (item.r != 1) return;
            //MsgBox("提示", "查看消息" + item.fidx);
            window.location.href = "friendmessage.html?touser=" + item.fidx;
        },
        tapApply: function tapApply(item) {
            Apply(item);
        },
        tapDel: function tapDel(item) {
            Delete(item);
        }

    },
    created: function created() { },
    mounted: function mounted() {
        this.init = true;
    }
});

function Apply(item) {
    if (isSimulation) {
        //var jMsg = sim.friendsapply;
        //var msg = eval("(" + jMsg + ")");
        item.r = 1;
        //showInfo(msg);
    } else {
        //app.curritem = item;
        requestServer("Friend/Apply", "touser=" + item.fidx);
    }
}

function Delete(item) {
    //MsgBox("Del", index);
    if (isSimulation) {
        //var jMsg = sim.friendsdelete;
        //var msg = eval("(" + jMsg + ")");
        //showInfo(msg);
        app.items.splice(index, 1);
    } else {
        requestServer("Friend/Delete", "touser=" + item.fidx);
    }
}

function afterAction(msg) {
    if (msg.info.r == 0) {
        for (var i = 0; i < app.items.length; i++) {
            if (app.items[i].fidx == msg.info.touser) {
                app.items.splice(i, 1);
            }
        }
    }
    else {
        for (var i = 0; i < app.items.length; i++) {
            if (app.items[i].fidx == msg.info.touser) {
                app.items[i].r = msg.info.r;
            }
        }
    }
}

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.friends;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    } else {
        SetTitle("好友");
        requestServer("Friend/GetFriends");
    }
}

function showInfo(msg) {
    app.items = msg.info.friends;
} // JavaScript source code

function onGameNativeMsg(source, msg) {
    switch (source) {
        case "server":
            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                if (msg.request == "GetFriends") showInfo(msg);//
                else if (msg.request == "Apply") afterAction(msg);
                else if (msg.request == "Delete") afterAction(msg);
            }

            break;

        case "peer":
            break;

        case "system":
            switch (msg.code) {
                case 220:
                case "220":
                case "220.0":
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand("exit", "");
                    //window.location.href = "my.html";

                    break;

                default:
                    break;
            }
    }
}
