﻿function escape2Html(str) {
    var arrEntities = { 'lt': '<', 'gt': '>', 'nbsp': ' ', 'amp': '&', 'quot': '"' };
    return str.replace(/&(lt|gt|nbsp|amp|quot);/ig, function (all, t) { return arrEntities[t]; });
}

function getInfo() {
    //requestServer("Message/Read");
    var mtype = "M";
    if (isSimulation) {
        var jMsg = sim.msginfo;
        //var msg = eval("(" + jMsg + ")");
        var msg = JSON.parse(jMsg);
        showInfo(msg);
    }
    else if (GetQueryString("mtype") == "N") {
        requestServer("Message/Get", "idx=" + GetQueryString("idx") + "&mtype=N");
        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"公告详情\"}');
    }
    else {
        requestServer("Message/Get", "idx=" + GetQueryString("idx"));
        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"消息详情\"}');
    }
}

function read() {
    if (isSimulation) {
        alert("已阅！");
    }
    else {
        requestServer("Message/Read", "idx=" + app.idx + "&mtype=" + app.mtype);
    }
}

function showInfo(msg) {
    if (msg.request != "Get" || msg.info == null || msg.info == undefined) {
    }
    else{
        app.idx = msg.info.idx;
        app.title = msg.info.title;
        app.details = escape2Html(msg.info.message);
        app.date = msg.info.date;
        app.mtype = msg.info.mtype;

        setTimeout(read, 2000);
    }
}

// JavaScript source code
function onGameNativeMsg(source, msg) {
    switch (source) {
        case 'server':
            if (msg.code == 200) {
                showInfo(msg);
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    //JavaScriptInterface.nativeCommand('exit', '');
                    //window.history.back();
                    window.location.href = "messages.html";
                    break;
                default:
                    break;
            }
    }
}