﻿function dologout() {
    requestServer("Account/Logout");
}

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.examscores;
        var msg = eval("(" + jMsg + ")");
        var msgmatchs = eval("(" + sim.matchhisall + ")");
        showInfo(msg);
        showMatchHis(msgmatchs);
    }
    else {
        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"我的测评\"}');
        requestServer("Exam/GetUserScores");
        requestServer("Account/GetAccountBind");
        requestServer("Exam/GetUserMatchHis2");
    }
}

function showInfo(msg) {
    var items = [];
    for (var i = 0; i < msg.info.scores.length; i++) {
        var ex = msg.info.scores[i];
        items.push({ label: ex.gamename, level: ex.levelname, value: ex.score, max: ex.max, current: ex.currexp, code: ex.gamecode });
    }
    //app.iszhidao = msg.info.iszhidao;
    app.items = items;
    app.nickname = msg.info.nickname;
    app.total = msg.info.total;
    app.stars = new Array(app.total + 1).join("★");
    app.otherstars = new Array(20 - app.total + 1).join("★");
}

function setAccountBind(msg) {
    app.iszhidao = msg.info.zd == 1;
}

function showMatchHis(msg) {
    //myVue.pageTitle = new Array();
    //myVue.pageTitle[0] = '我的战绩';
    //myVue.items[0] = new Array();
    for (var i = 0; i < msg.info.matchs.length; i++) {
        app.matchs.push({
            type: getGameName(msg.info.matchs[i].gamecode),
            time: msg.info.matchs[i].datetime,
            score: msg.info.matchs[i].score,
            gamecode: msg.info.matchs[i].gamecode,
            r: msg.info.matchs[i].r,
            midx: msg.info.matchs[i].midx,
        });
        //myVue.items[0][i].type = getGameName(msg.info.matchs[i].gamecode);
        //myVue.items[0][i].time = msg.info.matchs[i].datetime;
        //myVue.items[0][i].value = msg.info.matchs[i].score;
    }
}

function getGameName(gamecode) {
    switch (gamecode) {
        case 'PS2S': return '沟通成本';
        case 'PS2C': return '说人话';
        case 'PA': return '有效说服';
        case 'PAM': return '面试沟通';
    }
    return "";
}

// JavaScript source code
function onGameNativeMsg(source, msg) {
    switch (source) {
        case 'server':

            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                if (msg.request == "GetUserScores") {
                    showInfo(msg);
                }
                else if (msg.request == "GetAccountBind") {
                    setAccountBind(msg);
                }
                else if (msg.request == "GetUserMatchHis2") {
                    showMatchHis(msg);
                }
                else if (msg.request == "Logout") {
                    JavaScriptInterface.nativeCommand('logout', '');
                }
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand('exit', '');
                    //window.location.href = "my.html";
                    break;
                default:
                    break;
            }
    }
}