﻿function dologout() {
    requestServer("Account/Logout");
}

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.examscore;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    else {
        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"我的测评\"}');
        requestServer("Exam/GetUserScore");
    }
}

function showInfo(msg) {
    app.iszhidao = msg.info.iszhidao;
    app.nickname = msg.info.nickname;
    app.total = msg.info.score;
    app.score = msg.info.score;
    app.currexp = msg.info.currexp;
    app.min = msg.info.min;
    app.max = msg.info.max;
    app.stars = new Array(msg.info.star + 1).join("★");
    app.otherstars = new Array(5 - msg.info.star + 1).join("★");
    app.ismax = msg.info.star == 5;
    if (app.ismax) {
        app.next = 0;
        app.max = app.currexp;
    }
    else {
        //(a*4/b+1)*(b/4)-a
        app.next = parseInt((app.currexp - app.min) * 4 / (app.max - app.min) + 1) * parseInt((app.max - app.min) / 4) - (app.currexp - app.min);
    }
}


// JavaScript source code
function onGameNativeMsg(source, msg) {
    switch (source) {
        case 'server':

            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                if (msg.request == "GetUserScore") {
                    showInfo(msg);
                }
                else if (msg.request == "Logout") {
                    JavaScriptInterface.nativeCommand('logout', '');
                }

            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand('exit', '');
                    //window.location.href = "my.html";
                    break;
                default:
                    break;
            }
    }
}