"use strict";

var step = 3; //辩论

var app = new Vue({
  el: "#app",
  data: {
    init: false,
    style: "",
    audio: null,
    //    startaudio: null,
    //	endaudio: null,
    definfo: {
      matchidx: 0,
      title: "",
      description: "",
      description2: "",
      userrole: "",
      totaltime: 0,
      mptime: 0,
      dptime: 0,
      players: [{
        nickname: "",
        role: "",
        bacount: 0,
        bncount: 0,
        bmcount: 0
      }, {
        nickname: "",
        role: "",
        bacount: 0,
        bncount: 0,
        bmcount: 0
      }, {
        nickname: "",
        role: "",
        bacount: 0,
        bncount: 0,
        bmcount: 0
      }, {
        nickname: "",
        role: "",
        bacount: 0,
        bncount: 0,
        bmcount: 0
      }, {
        nickname: "",
        role: "",
        bacount: 0,
        bncount: 0,
        bmcount: 0
      }],
      maxscore: 30,
      points: [10, 10, 10, 10, 10],
      newscore: ['', '', '', '', ''],
      playerme: 0
    },
    //	judgeinfo: {role: 'C', start: 0, finish: 100000},
    judgerole: '',
    initdata: {
      matchidx: 0,
      stage: 4,
      micseq: [],
      mpos: 0,
      finishs: [] //		timeremain: 0,
      //	  prescore: ''

    },
    error: false,
    // 举报窗口
    inputReason: false,
    myreason: "",
    popup: false,
    popupdata: {
      title: "",
      body: ""
    },
    actionHintText: "",
    timerRun: true,
    endTimer: null,
    time: 0,
    // 累计用时
    mytimeremain: 0,
    finished: false,
    width: 0,
    btnText: "",
    btnAction: true,
    speaking: false //	  exit: false

  },
  components: {},
  watch: {},
  beforeMount: function beforeMount() {
    // 获取数据
    this.height = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
    this.style = "min-height: " + this.height + "px";
    this.audio = document.createElement("audio"); //      this.audio.src = "./sound/ready.mp3";
    //    this.startaudio = document.createElement("audio");
    //    this.startaudio.src = "./sound/ready.mp3";
    //    this.endaudio = document.createElement("audio");
    //    this.endaudio.src = "./sound/ticks.mp3";
  },
  computed: {
    // 麦序背景
    maskPos: function maskPos() {
      return "width: " + this.initdata.mpos * 40 + "px";
    },
    // 主按钮
    Btn: function Btn() {
      var style = "";
      var mypos = this.initdata.micseq.indexOf("我");

      if (this.finished) {
        style = "talk disabled";
        this.btnText = "取消发言";
        this.actionHintText = "您已放弃发言";
        this.btnAction = false;
      } else if (this.definfo.totaltime - this.time > 0) {
        if (mypos < 0) {
          style = "talk green";
          this.btnText = "我要发言";
          this.actionHintText = "请申请发言，进入麦序";
        } else if (this.initdata.micseq.indexOf("我") == 0) {
          style = "talk red";
          this.btnText = "停止发言";
          this.actionHintText = "您的发言已开始，按“停止发言”退出发言";
        } else if (mypos < this.initdata.mpos) {
          style = "talk disabled";
          this.btnText = "我要发言";
          this.actionHintText = "稍后将轮到您立论发言，请等待";
        } else {
          style = "talk green un";
          this.btnText = "取消发言";
          this.actionHintText = "点击“取消发言”，可退出麦序";
        }

        if (this.initdata.micseq.length == 0) {
          this.actionHintText = "目前无人发言。请申请发言，进入麦序";
        }

        this.btnAction = true;
      } else {
        style = "talk disabled";
        this.btnText = "取消发言";
        this.actionHintText = "讨论时间已用完";
        this.btnAction = false;
      }

      return style;
    },
    // 弃按钮
    exit: function exit() {
      return this.initdata.mpos == 0 && this.initdata.micseq.indexOf("我") != 0 && !this.finished && this.time > 150;
    },
    // 圆环倒计时
    stroke: function stroke() {
      if ("我" == this.initdata.micseq[0]) {
        return this.width * ((this.initdata.mpos > 0 ? this.definfo.mptime : this.definfo.dptime) - this.mytimeremain) + " 142";
      } else {
        return "0 142";
      }
    },
    formatTime: function formatTime() {
      if ("我" == this.initdata.micseq[0]) {
        var minute = parseInt(this.mytimeremain / 60);
        var second = parseInt(this.mytimeremain % 60);

        var zero = function zero(v) {
          return v >> 0 < 10 ? "0" + v : v;
        };

        return [zero(minute), zero(second)].join(":");
      } else {
        return "00:00";
      }
    }
  },
  methods: {
    // 举报
    tapMenu: function tapMenu() {
      this.error = !this.error;
      this.myreason = "";
      this.inputReason = false;
    },
    tapReason: function tapReason() {
      this.inputReason = true;
    },
    nameStyle: function nameStyle(index) {
      //      if (this.initdata.finishs[index] == 1) {
      //        return "graytext";
      //      } else {
      var role = this.definfo.players[index].role == this.definfo.userrole ? "我" : this.definfo.players[index].role; //        return role == this.initdata.micseq[0] ? "label active" : "label";

      var thisclass = role == this.initdata.micseq[0] ? "active" : "";
      return role == '我' ? thisclass + ' me' : thisclass; //        return role == this.initdata.micseq[0] ? "active" : "";
      //      }
    },
    // 标题
    defText: function defText(val) {
      var _this = this;

      var text = "";
      this.definfo.players.forEach(function (d) {
        if (d.role == val) {
          text = val + ". " + d.nickname;

          if (d.role == _this.definfo.userrole) {
            text += "（我）";
          }
        }
      });
      return text;
    },
    // 计时
    timer: function timer() {
      var self = this;

      if (this.init) {
        //规定发言（陈词）
        if ("我" == this.initdata.micseq[0]) {
          if (this.mytimeremain > 0) {
            this.mytimeremain--;

            if (this.mytimeremain == 10) {
              app.audio.src = "./sound/ticks.mp3";
              app.audio.play();
            }
          } else {
            requestServer(apiCode, "GameAction", "act=23"); //结束发言

            sendPeerMsg("MatchStatusChanged");
          }
        } //自由发言


        if (this.initdata.mpos == 0) {
          if (this.definfo.totaltime - this.time > 0) {
            this.time++;

            if (this.definfo.totaltime - this.time == 10) {
              app.audio.src = "./sound/ticks.mp3";
              app.audio.play();
            }

            var m = parseInt((this.definfo.totaltime - this.time) / 60);
            var s = parseInt((this.definfo.totaltime - this.time) % 60);
            var t = (m > 9 ? m : "0" + m) + ":" + (s > 9 ? s : "0" + s);
            JavaScriptInterface.nativeCommand('setTitle', '{"title":"面试沟通（' + t + '）"}');
          } else {
            //			  updatePrescore();
            requestServer(apiCode, "GetMatchStatusInfo");
            this.endTimer = setInterval('requestServer(apiCode, "GetMatchStatusInfo")', 1000);
            this.timerRun = false;
          }
        }
      }

      if (this.timerRun) {
        if (this.definfo.totaltime % 5 == 0) {
          requestServer(apiCode, "GetMatchStatusInfo");
        }

        setTimeout(this.timer, 1000);
      }
    },
    //点击显示题目详情
    tapDetail: function tapDetail() {
      var str = this.definfo.description.replace(/\|/g, "<br>") + "<br>" + this.definfo.description2.replace(/\|/g, "<br>");
      this.popupdata = {
        title: this.definfo.title,
        //          body: this.definfo.description + this.definfo.description2
        body: str
      };
      this.popup = true;
    },
    tapZan: function tapZan(idx, val) {
      if (this.definfo.players[idx].role != this.judgerole) {
        return;
      }

      clearTimeout(scoringTimer);
      clearTimeout(noScoringTimer);
      requestServer(apiCode, "Judge", "torole=" + this.definfo.players[idx].role + "&score=" + val);
      sendPeerMsg("newscore", {
        "torole": idx,
        "score": val
      });
      this.$set(this.definfo.newscore, idx, val);
      currentbubble = idx;
      setTimeout('app.$set(app.definfo.newscore, currentbubble, "")', 2000);
      /*	  if(this.initdata.prescore = ''){
      		  return;
      	  }
            this.definfo.players[idx][val]++;
            var s = "";
      
            for (var i = 0; i < this.definfo.players.length; i++) {
              if (
                this.definfo.players[i].role != this.definfo.userrole &&
                this.definfo.players[i].role != ""
              ) {
                s += this.definfo.players[i].bacount + "_";
                s += this.definfo.players[i].bncount + "_";
                s += this.definfo.players[i].bmcount + "|";
              }
            }
      
            s = s.slice(0, -1);
      	  this.initdata.prescore = s;
      	  
      //      requestServer(apiCode, "UpdatePreScore", "prescore=" + s);
      //      sendPeerMsg("MatchStatusChanged");*/
    },
    tapError: function tapError(reason) {
      this.error = false;
      this.inputReason = false;

      if (reason != undefined) {
        requestServer("Game", "Report", "reason=" + reason);
      } else {
        if (this.myreason == "") {
          JavaScriptInterface.nativeCommand("msgBox", '{"title":"提示","msg":"请输入举报理由","t":"3"}');
        } else {
          requestServer("Game", "Report", "reason=" + this.myreason);
        }
      }
    },
    // 发言
    tapTalk: function tapTalk() {
      if (!this.btnAction) return;

      if (this.btnText == "我要发言") {
        requestServer(apiCode, "GameAction", "act=21"); //申请发言
      } else if (this.btnText == "取消发言") {
        requestServer(apiCode, "GameAction", "act=22"); //麦序中。取消发言
      } else if (this.btnText == "停止发言") {
        app.audio.pause();
        requestServer(apiCode, "GameAction", "act=23"); //发言中。停止发言
      }

      sendPeerMsg("MatchStatusChanged");
    },
    // 弃
    tapExit: function tapExit() {
      requestServer(apiCode, "GameAction", "act=31");
      sendPeerMsg("MatchStatusChanged");
    }
  },
  created: function created() {
    myVue = this;
  },
  mounted: function mounted() {
    this.timer(); //    setInterval(updatePrescore, 20000);
  }
});

function requestInitInfo() {
  requestServer(apiCode, "GetInitInfo");
  requestServer(apiCode, "GetMatchStatusInfo"); //  requestServer(apiCode, "GetPreScore");

  if (isSimulation) {
    //    onNativeMsg("server", '{"code":200,"request":"GetPreScore","info":{"prescore":"1_0_0|1_1_0|1_1_0|1_0_0"}}');
    onGameNativeMsg("server", {
      "code": 200,
      "request": "GetMatchStatusInfo",
      "info": {
        "matchidx": 23839,
        "stage": 4,
        "micseq": ["B", "C", "D", "E"],
        "mpos": 0,
        "role": "B",
        "judgeinfo": {
          "role": "B",
          "start": 0,
          "finish": 5000
        },
        "points": [0, 10, 10, 10, 10],
        "totaltimeremain": 300,
        "currtimeremain": 30
      }
    }); //    onGameNativeMsg("server", {"code":200,"request":"GetMatchStatusInfo","info":{"matchidx":22909,"stage":5,"countdown":2829,"allsortnum":3,"waituser":3,"sortnum":0,"roles":[{"role":"A","title":"David2","count":0},{"role":"C","title":"david3","count":0}],"gamecode":"PAM","prescorecount":0}});

    onGameNativeMsg("server", {
      "code": 200,
      "request": "GetInitInfo",
      "info": {
        "matchidx": 23837,
        "title": "图书馆",
        "description": "学校的图书馆需要扩充书籍的类型，本次计划需要采购三种不同类型的书籍。有人喜欢看言情小说；有人喜欢看日本漫画，有些人喜欢美国漫画；有人喜欢看玄幻小说；有些人为了能够更方便地写论文选择经典书籍……",
        "description2": "作为学校的一名学生，你希望能够在自己学校的图书馆找到自己感兴趣的书籍，请尽量说服你们的校长采购这一类书籍吧！",
        "users": [{
          "nickname": "胖胖",
          "role": "A"
        }, {
          "nickname": "David2",
          "role": "B"
        }, {
          "nickname": "david3",
          "role": "C"
        }, {
          "nickname": "187****573...",
          "role": "D"
        }, {
          "nickname": "chenlan",
          "role": "E"
        }],
        "userrole": "A",
        "mptime": 30,
        "dptime": 45,
        "totaltime": 600
      }
    });
    onGameNativeMsg("peer", {
      "type": "newscore",
      "torole": 1,
      "score": "+2"
    });
  }
}
/*
function updatePrescore() {
	if(myVue.initdata.prescore != ""){
		requestServer(apiCode, "UpdatePreScore", "prescore=" + myVue.initdata.prescore);
	}
//  requestServer(apiCode, "GetMatchStatusInfo");
}
*/


function updateParams() {
  for (var i = 0; i < myVue.initdata.micseq.length; i++) {
    if (myVue.initdata.micseq[i] == myVue.definfo.userrole) {
      myVue.initdata.micseq[i] = "我";
    }
  }

  myVue.width = 142 / (myVue.initdata.mpos > 0 ? myVue.definfo.mptime : myVue.definfo.dptime);

  if ("我" == myVue.initdata.micseq[0]) {
    JavaScriptInterface.nativeCommand("micOn", "");

    if (!myVue.speaking) {
      if (myVue.initdata.mpos > 0) {
        myVue.mytimeremain = myVue.definfo.mptime;
      } else {
        myVue.mytimeremain = myVue.definfo.dptime;
      }

      myVue.speaking = true;
      myVue.audio.src = "./sound/ready.mp3";
      myVue.audio.play();
      sendPeerMsg("MatchStatusChanged");
    }
  } else {
    JavaScriptInterface.nativeCommand("micOff", "");
    myVue.speaking = false;
  }

  if (myVue.time > -1) {
    myVue.init = true;
  }
}
/*
function setPrescore(s) {
	if(s != '') {
		myVue.initdata.prescore = s;
	}
	var j = 0;
//	var s = myVue.initdata.prescore;
	var a = myVue.initdata.prescore.split("|");
	
	for (var i = 0; i < myVue.definfo.players.length; i++) {
		if (
		  j < a.length &&
		  myVue.definfo.players[i].role != myVue.definfo.userrole &&
		  myVue.definfo.players[i].role != ""
		) {
		  var b = a[j].split("_");
		  myVue.definfo.players[i]['bacount'] = b[0];
		  myVue.definfo.players[i]['bncount'] = b[1];
		  myVue.definfo.players[i]['bmcount'] = b[2];
		  j++;
		}
	}
}
*/


var scoringTimer = null;
var noScoringTimer = null;
var currentbubble = 0;

function onGameNativeMsg(source, msg) {
  switch (source) {
    case "server":
      switch (msg.request) {
        //        case "UpdatePreScore":
        case "GetMatchStatusInfo":
        case "GameAction":
        case "Judge":
          switch (msg.info.stage) {
            case 4:
              myVue.initdata.micseq = msg.info.micseq;
              myVue.initdata.mpos = msg.info.mpos;
              myVue.time = myVue.definfo.totaltime - msg.info.totaltimeremain; //              myVue.initdata.finishs = msg.info.finishs;
              //              myVue.finished = myVue.initdata.finishs[myVue.definfo.playerme];

              myVue.definfo.points = msg.info.points;
              var max = Math.max.apply(null, msg.info.points);

              if (max > myVue.definfo.maxscore) {
                myVue.definfo.maxscore = (parseInt(max / 30) + 1) * 30;
              }

              if (msg.info.judgeinfo != undefined) {
                //				  myVue.judgeinfo = msg.info.judgeinfo;
                myVue.judgerole = msg.info.judgeinfo.start == 0 && msg.info.judgeinfo.finish > 0 ? msg.info.judgeinfo.role : '';
                clearTimeout(scoringTimer);
                clearTimeout(noScoringTimer);

                if (msg.info.judgeinfo.start > 0 && msg.info.judgeinfo.start != 1000000) {
                  scoringTimer = setTimeout('requestServer(apiCode, "GetMatchStatusInfo")', msg.info.judgeinfo.start);
                }

                if (msg.info.judgeinfo.start >= 0 && msg.info.judgeinfo.finish != 1000000) {
                  noScoringTimer = setTimeout('requestServer(apiCode, "GetMatchStatusInfo")', msg.info.judgeinfo.finish);
                }
              }

              updateParams();
              break;

            case 6:
              app.timerRun = false;
              clearInterval(myVue.endTimer);
              JavaScriptInterface.nativeCommand("micOff", "");
              window.location.href = "result.html";
              break;

            /*           case 5:
            //			  updatePrescore();
                         app.timerRun = false;
            		  clearInterval(myVue.endTimer);
                         JavaScriptInterface.nativeCommand("micOff", "");
                         window.location.href = "four.html";
                         break;*/
          }

          break;

        case "GetInitInfo":
          myVue.definfo.description = "议题内容：" + msg.info.description;
          myVue.definfo.description2 = msg.info.description2;

          for (var i = 0; i < msg.info.users.length; i++) {
            myVue.definfo.players[i].nickname = msg.info.users[i].nickname;
            myVue.definfo.players[i].role = msg.info.users[i].role;

            if (msg.info.users[i].role == msg.info.userrole) {
              myVue.definfo.playerme = i;
            }
          }

          myVue.definfo.mptime = msg.info.mptime;
          myVue.definfo.dptime = msg.info.dptime;
          myVue.definfo.totaltime = msg.info.totaltime;
          myVue.definfo.userrole = msg.info.userrole; //如果GetMatchStatusInfo应答已先期收到（所用时间为负），重新计算参数，开始发言

          if (myVue.time < 0) {
            myVue.time += myVue.definfo.totaltime;
            updateParams();
          } //		  setPrescore('');


          break;

        /*        case "GetPreScore":
        		
        //		  myVue.initdata.prescore = msg.info.prescore;
        		  setPrescore(msg.info.prescore);
        
                  break;
        */

        case "Report":
          JavaScriptInterface.nativeCommand("msgBox", '{"title":"提示","msg":"服务器已收到举报","t":"3"}');
          break;
      }

      break;

    case "peer":
      switch (msg.type) {
        case "MatchStatusChanged":
          requestServer(apiCode, "GetMatchStatusInfo");
          break;

        case "newscore":
          app.$set(app.definfo.newscore, msg.torole, msg.score);
          currentbubble = msg.torole;
          setTimeout('app.$set(app.definfo.newscore, currentbubble, "")', 2000);
          break;
      }

      break;

    case "system":
      switch (msg.code) {
        case 232:
        case "232":
        case "232.0":
          requestServer(apiCode, "GameAction", "act=52");
          sendPeerMsg("MatchStatusChanged");
          break;

        case 233:
        case "233":
        case "233.0":
          requestServer(apiCode, "GameAction", "act=51");
          break;
      }

  }
}