"use strict";

var step = 2; //准备辩论

var app = new Vue({
  el: "#app",
  data: {
    init: false,
    time: 30,
    timeText: '',
    promptText: '倒数计时结束，比赛正式开始',
    style: ''
  },
  components: {},
  watch: {},
  beforeMount: function beforeMount() {
    // 获取数据
    this.height = window.innerHeight || document.documentElement.clientHeight || document.body.clientHeight;
    this.style = "min-height: ".concat(this.height, "px");
    var t = window.location.href.split("=")[1];

    if (t != undefined) {
      if (t == 0) {
        this.promptText = '即将返回比赛';
        this.time = 3;
      } else {
        this.time = t;
      }
    }
  },
  computed: {},
  methods: {
    // 倒计时
    timer: function timer() {
      if (this.time > 0) {
        this.time--;
        this.timeText = this.time < 10 ? "0".concat(this.time) : "".concat(this.time);
        setTimeout(this.timer, 1000);
      } else {
        //          alert('倒计时结束')
        window.location.href = "pa_three.html";
      }
    }
  },
  created: function created() {
    myVue = this;
  },
  mounted: function mounted() {
    this.init = true;
    this.timer();
  }
});
var inroom = false;

function requestInitInfo() {
  requestServer(apiCode, "GetInitInfo");

  if (isSimulation) {
    onGameNativeMsg('server', {
      "request": "GetInitInfo",
      "info": {
        "matchidx": 551,
        "title": "年终福利",
        "description": "快到年终了...",
        "description2": "最终会...",
        "options": [{
          "title": "旅游",
          "description": "开阔视野",
          "role": "A"
        }, {
          "title": "温泉",
          "description": "放松身心",
          "role": "B"
        }, {
          "title": "烧烤",
          "description": "增进友谊",
          "role": "C"
        }, {
          "title": "西餐",
          "description": "浪漫一下",
          "role": "D"
        }, {
          "title": "现金",
          "description": "实惠啊",
          "role": "E"
        }],
        "userrole": "B",
        "mptime": 30,
        "dptime": 120
      }
    });
  } //	JavaScriptInterface.nativeCommand('createRoom', matchidx);

}

function onGameNativeMsg(source, msg) {
  switch (source) {
    case 'server':
      switch (msg.request) {
        case 'GetInitInfo':
          document.getElementById("title").innerHTML = msg.info.title;
          document.getElementById("desc").innerHTML = msg.info.description;
          document.getElementById("desc2").innerHTML = msg.info.description2;

          for (var i = 0; i < msg.info.options.length; i++) {
            if (msg.info.userrole == msg.info.options[i].role) {
              document.getElementById("myview").innerHTML = msg.info.userrole + "." + msg.info.options[i].title;
              document.getElementById("myview_desc").innerHTML = msg.info.options[i].description;
            }
          }

          if (!inroom) {
            JavaScriptInterface.nativeCommand('createRoom', '{\"name\":\"' + matchidx + '\"}');
          }

          break;
      }

      break;

    case 'system':
      switch (msg.code) {
        case 226:
        case '226':
        case '226.0':
          JavaScriptInterface.nativeCommand('joinRoom', '{\"name\":\"' + matchidx + '\"}');
          break;

        case 227:
        case '227':
        case '227.0':
          doExit('创建聊天室失败！');
          break;

        case 228:
        case '228':
        case '228.0':
          requestServer("Game", "SubmitChannelId", "channelid=" + msg.info);
          inroom = true;
          JavaScriptInterface.nativeCommand('micOff', '');
          break;

        case 229:
        case '229':
        case '229.0':
          doExit('加入聊天室失败！');
          break;

        case 232:
        case '232':
        case '232.0':
          requestServer(apiCode, "GameAction", "act=52");
          break;

        case 233:
        case '233':
        case '233.0':
          requestServer(apiCode, "GameAction", "act=51");
          break;
      }

  }
}