﻿$(document).ready(function () {
    if (isSimulation) {
        getInfo();
    }
    //JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"gettoken()\"}');
    JavaScriptInterface.nativeCommand('getToken', '');
    JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"领取奖励\"}');

});

function getInfo() {

    if (isSimulation) {
        //var jMsg = '{"code":200,"info":{"groupidx":1,"title":"青铜联赛","ranklist":[{"UserIdx":90,"nickname":"胡昕","matchcount":2,"score":37898,"rank":1,"me":true,"point":7},{"UserIdx":113,"nickname":"user32","matchcount":1,"score":37283,"rank":2,"me":false,"point":5}],"matchs":[{"rolea":"胡昕","roleb":"user32","score":37283,"starttime":"2018-08-05T18:22:16.217","endtime":"2018-08-05T18:23:16.65","sec":60,"secformat":"1分0秒"},{"rolea":"胡昕","roleb":"user32","score":37898,"starttime":"2018-08-05T18:03:03.733","endtime":"2018-08-05T18:04:03.677","sec":59,"secformat":"59秒"}]}}';
        var jMsg = '{ "code": 200, "info": { "totalprize": "¥1.50", "prizes": [ { "PrizeTitle": "内测一阶段", "PrizeDate": "2018-08-10T00:00:00", "Prize": 51, "Code": "466B76F5", "Status": 1, "PrizeFormat": "¥0.51" }, { "PrizeTitle": "内测二阶段", "PrizeDate": "2018-08-12T00:00:00", "Prize": 99, "Code": "24432828", "Status": 1, "PrizeFormat": "¥0.99" }, { "PrizeTitle": "内测三阶段", "PrizeDate": "2018-08-14T00:00:00", "Prize": 108, "Code": "E75B6593", "Status": 0, "PrizeFormat": "¥1.08" } ] } }';
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    }
    else {
        requestServer("League/GetUserPrizeList");
    }
}

function copy(code) {
    if (isSimulation) {
        alert(code);
    }
    else {
        JavaScriptInterface.nativeCommand('copy', '{\"text\":\"' + code + '\"}');
        //JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"领奖码：' + code + '已复制到剪贴板\"}');
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"领奖码：' + code + '已复制到剪贴板\",\"t\":\"3\"}');
    }
}

function showInfo(msg) {

    //$(".prizetitle").html("累计奖金：" + msg.info.totalprize);
    $("#prizes li").remove();
    //<li><i></i><span class="kuai c">8</span>9485 胡子</li>
    for (var i = 0; i < msg.info.prizes.length; i++) {
        var ex = msg.info.prizes[i];
        var me = ex.me;
        var text = "<li><span class='title'>" + ex.PrizeTitle + "</span> <span class='prize'>" + ex.PrizeFormat + "</span>";

        if (ex.Status == 0) {
            text = text + "<span class='code'>处理中...</span>";
        }
        else {
            text = text + '<span class="code">领奖码：' + ex.Code + '</span><span><img src="images/copy.png"  onclick="copy(\'' + ex.Code + '\');" ></span>';
        }
        text = text + "</li>";

        $("#prizes").append(text).trigger('create');
    }
    //var test = "<li><span class='title'>测试</span> <span class='prize'>￥0.01</span>";
    //test = test + '<span class="code">领奖码：SDF345ER</span> <input type="button" value="复制" onclick="copy(\'SDF345ER\');" />';
    //test = test + "</li>";

    //$("#prizes").append(test).trigger('create');
}

// JavaScript source code
function onNativeMsg(source, jMsg) {
    var msg = eval("(" + jMsg + ")");
    //JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case 'server':

            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                showInfo(msg);
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    window.location.href = "my.html";
                    break;
                case 223:
                case '223':
                case '223.0':
                    token = msg.info;
                    getInfo();
                    // initStepTwo();
                    break;
                default:
                    break;
            }
    }
}