﻿"use strict";

var app = new Vue({
    el: "#app",
    data: {
        init: false,
        style: "",
        items: [
            {
                label: "双倍券",
                time: "",
                state: 0
            }
        ]
    },
    components: {},
    watch: {},
    beforeMount: function beforeMount() {
        // 获取数据
        this.height =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.body.clientHeight;
        this.style = "min-height: " + this.height + "px";
    },
    computed: {},
    methods: {
        tap: function tap() {
            console.log("tap");
        }
    },
    created: function created() { },
    mounted: function mounted() {
        this.init = true;
    }
});

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.tickets;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
    } else {
        JavaScriptInterface.nativeCommand("setTitle", '{"title":"双倍券"}');
        requestServer("User/GetUserTicketsList");
    }
}

function showInfo(msg) {
    var items = [];

    for (var i = 0; i < msg.info.tickets.length; i++) {
        var ex = msg.info.tickets[i]; //var text = '<li><a href="fbdetail.html?idx=' + ex.Idx + '">';

        var title = "双倍券";

        if (ex.status == 1) {
            title = title + "（已使用）";
        } else if (ex.status == 2) {
            title = title + "（已过期）";
        } //text = text + title + "</a><i>";
        //$("#list").append(text).trigger('create');

        items.push({
            label: title,
            time: ex.remark,
            state: ex.status
        });
    }

    for (var i = msg.info.tickets.length; i < 10; i++) {
        items.push({});
    }

    app.items = items;
} // JavaScript source code

function onGameNativeMsg(source, msg) {
    switch (source) {
        case "server":
            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgbox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                showInfo(msg);
            }

            break;

        case "peer":
            break;

        case "system":
            switch (msg.code) {
                case 220:
                case "220":
                case "220.0":
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand("exit", ""); //window.location.href = "my.html";

                    break;

                default:
                    break;
            }
    }
}
