﻿function logout() {
    requestServer("Account/Logout");
}

function copyinvitecode(code) {
    if (isSimulation) {
        alert(code);
    }
    else {
        JavaScriptInterface.nativeCommand('copy', '{\"text\":\"' + code + '\"}');
        //JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"领奖码：' + code + '已复制到剪贴板\"}');
        JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"推荐码：' + code + '已复制到剪贴板\",\"t\":\"3\"}');
    }
}
var flag = false;
function useinvitecode() {
    var code = app.inviteinput.replace(/\"/g, "").replace(/\'/g, "");
    if (code.length == 0) {
        MsgBox("提示", "请输入推荐码！");
        return false;
    }
    if (isSimulation) {
        var useInviteMsg = eval("(" + sim.inviteresult0 + ")");
        showBindResult(useInviteMsg);
    }
    else {
        if (flag == false) {
            flag = true;
            var code = app.inviteinput.replace(/\"/g, "").replace(/\'/g, "");
            requestServer("User/UseInviteCode", "code=" + code);
        }
    }
}

function accountbind(accounttype) {
    var url = "accountbind.html?t=" + accounttype;
    window.location.href = url;
}

function submit() {
    var username = app.username; // $("#username").val();
    var nickname = app.nickname; // $("#nickname").val();
    var gender = app.sex; // $("input[name='sex']:checked").val();

    username = username.replace(/\"/g, "").replace(/\'/g, "");
    nickname = nickname.replace(/\"/g, "").replace(/\'/g, "");

    var regEn = /[`~!@#$%^&()_+<>?:"{},.\/;'[\]]/im,
        regCn = /[！#￥（——）：；“”‘、，|《。》？、【】[\]]/im;

    if (regEn.test(nickname) || regCn.test(nickname)) {
        MsgBox("提示", "昵称不能包含特殊字符.");
        return false;
    }

    if (regEn.test(username) || regCn.test(username)) {
        MsgBox("提示", "姓名不能包含特殊字符.");
        return false;
    }

    //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"' + username + '\"}');

    if (username.length == 0 || username == '请输入真实姓名') {
        MsgBox("提示", "请输入真实姓名！");
        //JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"请输入真实姓名！\",\"t\":\"3\"}');
        return false;
    }
    if (nickname.length == 0 || nickname == '请输入昵称') {
        MsgBox("提示", "请输入昵称！");
        //JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"请输入昵称！\",\"t\":\"3\"}');
        return false;
    }
    if (gender == undefined || gender == -1) {
        MsgBox("提示", "请选择性别！");
        //JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"请选择性别！\",\"t\":\"3\"}');
        return false;
    }

    //if (app.joinyear == undefined || app.joinyear == '') {
    //    MsgBox("提示", "请输入入学年份！");
    //    return false;
    //}
    var school = app.school.replace(/\"/g, "").replace(/\'/g, "");
    var joinyear = app.joinyear;
    var department = app.department.replace(/\"/g, "").replace(/\'/g, "");
    var studentno = app.studentno.replace(/\"/g, "").replace(/\'/g, "");

    var postinfo = '{"username": "' + username + '", "gender": '
        + gender + ',"nickname": "' + nickname + '", "school": "'
        + school + '","joinyear":' + joinyear + ', "department": "'
        + department + '","studentno": "' + studentno + '"}';

    requestServer("User/UpdateDetail", "", postinfo);
}

function getInfo() {
    if (isSimulation) {
        var jMsg = sim.userinfo;
        var msg = eval("(" + jMsg + ")");
        showInfo(msg);
        setAccountBind(eval("(" + sim.accountBind + ")"));
        //var inviteMsg = eval("(" + sim.invite0 + ")");
        //showInviteInfo(inviteMsg);
    }
    else {
        JavaScriptInterface.nativeCommand('setTitle', '{\"title\":\"个人账号\"}');
        JavaScriptInterface.nativeCommand('getVersion', '');
        requestServer("User/GetDetail");
        requestServer("Account/GetAccountBind");
        //requestServer("User/GetInviteInfo");
    }
}

function setAccountBind(msg) {
    app.bindwx = msg.info.wx;
    app.bindzd = msg.info.zd;
}

function showInviteInfo(msg) {
    app.invite = msg.info.invite;
    app.invitecode = msg.info.invitecode;
    app.inviteuser = msg.info.inviteuser;
}

function showInfo(msg) {
    //$("#nickname").val(msg.info.nickname);
    //$("#username").val(msg.info.username);
    //$("input[type=radio][name='sex'][value=" + msg.info.gender + "]").attr("checked", 'checked');
    app.nickname = msg.info.nickname;
    app.username = msg.info.username;
    app.sex = msg.info.gender;
    app.school = msg.info.school;
    app.joinyear = msg.info.joinyear;
    app.department = msg.info.department;
    app.studentno = msg.info.studentno;
    app.mobilebind = msg.info.mobilebind;
}

function showBindResult(msg) {
    //err：0绑定，-1 邀请码无效，-2 邀请人晚于被邀请人注册
    if (msg.info.err == 0) {
        app.invite = 1;
        app.inviteuser = msg.info.inviteuser;
    }
    else if (msg.info.err == -1) {
        app.prompt = "推荐码无效，请重新输入";
    }
    else if (msg.info.err == -2) {
        app.prompt = "推荐码对应的推荐人比您更晚使用本APP";//，推荐关系绑定失败
    }
}

function setMobileBind(msg) {
    app.mobilebind = msg.info.mobilebind;
}

// JavaScript source code
function onGameNativeMsg(source, msg) {
    //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"return\"}');
    switch (source) {
        case 'server':
            flag = false;
            if (msg.code == 200) {
                //JavaScriptInterface.nativeCommand('msgBox', '{\"tile\":\"提示\",\"msg\":\"' + msg.info + '\"}');
                if (msg.request == "GetDetail")
                    showInfo(msg);
                else if (msg.request == "UpdateDetail") {
                    JavaScriptInterface.nativeCommand('msgBox', '{\"title\":\"提示\",\"msg\":\"更新成功！\",\"t\":\"3\"}');
                    setTimeout("JavaScriptInterface.nativeCommand('exit', '')", 3000);
                    //window.location.href = "my.html";
                }
                else if (msg.request == "Logout") {
                    JavaScriptInterface.nativeCommand('logout', '');
                }
                else if (msg.request == "GetInviteInfo") {
                    showInviteInfo(msg);
                }
                else if (msg.request == "UseInviteCode") {
                    showBindResult(msg);
                }
                else if (msg.request == "GetAccountBind") {
                    setAccountBind(msg);
                }
                else if (msg.request == "GetMobileBind") {
                    setMobileBind(msg);
                }
            }
            break;
        case 'peer':
            break;
        case 'system':
            switch (msg.code) {
                case 220:
                case '220':
                case '220.0':
                    //JavaScriptInterface.nativeCommand('msgBox', 'exit');
                    JavaScriptInterface.nativeCommand('exit', '');
                    //window.history.back();
                    //window.location.href = "my.html";
                    break;
                case 225:
                case '225':
                case '225.0':
                    app.version = msg.info;
                    break;
                default:
                    break;
            }
    }
}